*CMZ :  2.01/01 21/11/95  13.25.31  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/03/95

      SUBROUTINE CH78BF (F, N)

************************************************************************
*
* Description: append blank space + real number F at the end of C78
*
* Called from: anywhere
*
* External references: CHDTOC
*
* Argument in/out description
*  F       in     real number to be appended
*  N       in     accuracy (N > 0); digits after . (N <=0)
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      INTEGER LENOCC, L, N
      REAL F
      CHARACTER*30 C30

#include "arte/Arte.ff"

      CALL CHDTOC (DBLE(F), N, '*', C30)

      L = LENOCC(C78)
      IF (L .LT. 78 - 1)  THEN
        C78(L+1:L+1) = ' '
        C78(L+2:) = C30
      END IF
      IF (L + LENOCC(C30) .GE. 78)  C78(78:78) = '!'

      END

************************************************************************
* End of CH78BF
************************************************************************
