*CMZ :          18/04/96  13.36.22  by  Hartwig Albrecht
*CMZ :  2.01/02 28/01/96  17.53.54  by  Hartwig Albrecht
*CMZ :  2.01/01 12/09/95  20.18.21  by  HERA-B
*-- Author :    Hartwig Albrecht   24/05/95

      SUBROUTINE DDFORT

************************************************************************
*
* Description: make Fortran initialization sequence YAUTTAB
*
* Called from:
*
* External reference:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, K3, NC, NF, ISUB
      CHARACTER CN*4, CSUB*4, CFC*1, CFF*1, CFT*48, CIO*56
      DATA CFT /''''/, CIO /'     + '''/

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL DDOPEN ('ArteTable', 'fi')

      WRITE (LDDEF, 1001)  ' '
      WRITE (LDDEF, 1001)
     +  'Created automatically by subroutine DDFORT'

      DO 70 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .NE. LDDEF_TAB)  GO TO 70

        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), CN)

        WRITE (LDDEF, 1001)  ' '
        C78 = 'C'
        C78(3:6) = CN
        CALL CHHTOC (IQ(HQDDEF_TEXT(1,K1)), C78(25:72))
        WRITE (LDDEF, 1001)  C78
        WRITE (LDDEF, 1001)  ' '

        NC = 0
        NF = 0
        CFC = ' '
        CFF = ' '
        CSUB = ' '
        CFT(2:) = ' '
        CIO(9:) = ' '

        DO 10 K2 = K1 + 1, NDDEF()

          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_MEN)  GO TO 20

          IF (IDDEF_FLAG(K2) .GE. LDDEF_ATT .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_INM)  THEN

            IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN
              NC = NC + MAX (IDDEF_DIM(K2), 1)
              CALL CHHTOC (IQ(HQDDEF_NAM2(K2)), CFC)
            ELSE
              NC = NC + 1
              CFC = 'I'
            END IF

            IF (CFC .EQ. CFF)  THEN
              NF = NF + MAX (IDDEF_DIM(K2), 1)
            ELSE
              IF (NF .NE. 0)  THEN
                CALL CHAPPI (CFT, NF)
                CALL CHAPPC (CFT, CFF)
              END IF
              CFF = CFC
              NF = MAX (IDDEF_DIM(K2), 1)
            END IF

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_FIL)  THEN

            IF (CIO(9:) .EQ. ' ')
     +        CALL CHHTOC (IQ(HQDDEF_TEXT(1,K2)), CIO(9:))
            GO TO 10

          ELSE IF (IDDEF_FLAG(K2) .GE. LDDEF_SUB)  THEN

            ISUB = IDDEF_FLAG(K2) - LDDEF_SUB
            CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CSUB)

          END IF

 10     CONTINUE

 20     C78 = '      CALL MMTABL (J    , ''    '','
        C78(21:24) = CN
        C78(28:31) = CN

        IF (IDDEF_DIV(K1) .EQ. 2)  THEN
          C78(35:) = 'IXEVNT)'
        ELSE
          C78(35:) = 'IXCONS)'
        END IF

        WRITE (LDDEF, 1001)  C78

        C78(27:) = ' '
        C78(15:17) = 'FMT'

        CALL CH78BI (NC)
        CALL CH78AC (',')

        CALL CH78BI (IDDEF_DIM(K1))
        CALL CH78AC (',')

        IF (NF .NE. 0)  THEN
          CALL CHAPPI (CFT, NF)
          CALL CHAPPC (CFT, CFF)
        END IF

        IF (CFT .NE. '''')  THEN

          CALL CH78BC (CFT)
          CALL CH78AC (''')')

        ELSE

          CALL CH78BC (''' '')')

        END IF

        WRITE (LDDEF, 1001)  C78

        C78(26:) = ' '

        IF (CIO(9:) .NE. ' ')  THEN

          C78(15:17) = 'FIL'
          WRITE (LDDEF, 1001)  C78
          CALL CHAPPC (CIO, ''')')
          WRITE (LDDEF, 1001)  CIO

        END IF

        IF (CSUB .NE. ' ')  THEN

          C78(15:17) = 'SUB'
          CALL CH78BC ('J')
          CALL CH78AC (CSUB)
          CALL CH78CI (ISUB)
          CALL CH78AC (')')
          WRITE (LDDEF, 1001)  C78

        END IF

 70   CONTINUE

C relations

      WRITE (LDDEF, 1001)
      WRITE (LDDEF, 1001) 'C relations'
      WRITE (LDDEF, 1001)

      DO 180 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .LT. LDDEF_RE1 .OR.
     +      IDDEF_FLAG(K1) .GT. LDDEF_REM)  GO TO 180

        C78 = '      CALL MMTREL (J    , ''    '',       , J    ,    ,'
     + // ' J    ,    ,  )'
        CALL CHHTOC (IQ(HQDDEF_NAM3(K1)), C78(21:24))
        C78(28:31) = C78(21:24)

        IF (IDDEF_DIV(K1) .EQ. 2)  THEN
          C78(35:40) = 'IXEVNT'
        ELSE
          C78(35:40) = 'IXCONS'
        END IF

        WRITE (C78(62:64), 1002) IDDEF_POS(K1)
        DO 110 K3 = K1, 1, -1
          IF (IDDEF_FLAG(K3) .EQ. LDDEF_TAB)  GO TO 120
 110    CONTINUE
 120    CALL CHHTOC (IQ(HQDDEF_NAME(K3)), C78(56:59))

        DO 170 K2 = 1, NDDEF()

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_TAB)  K3 = K2
          IF (HDDEF_NAM3(K1) .NE. HDDEF_NAM3(K2)) GO TO 170
          IF (IDDEF_FLAG(K2) .LT. LDDEF_IN1 .OR.
     +        IDDEF_FLAG(K2) .GT. LDDEF_INM)  GO TO 170

          CALL CHHTOC (IQ(HQDDEF_NAME(K3)), C78(44:47))
          WRITE (C78(50:52), 1002) IDDEF_POS(K2)

          WRITE (C78(67:67), 1003) IDDEF_REL(K1)

          WRITE (LDDEF, 1001)  C78

          DO 150 K3 = K1 + 1, NDDEF()
            IF (IDDEF_FLAG(K3) .LE. LDDEF_SKP .OR.
     +          IDDEF_FLAG(K3) .EQ. LDDEF_TEX)  GO TO 150
            IF (IDDEF_FLAG(K3) .NE. LDDEF_FIL)  GO TO 180

            CALL CHHTOC (IQ(HQDDEF_TEXT(1,K3)), CIO(9:))
            C78(15:17) = 'FIL'
            C78(26:) = ' '
            WRITE (LDDEF, 1001)  C78
            CALL CHAPPC (CIO, ''')')
            WRITE (LDDEF, 1001)  CIO

 150      CONTINUE

          GO TO 180

 170    CONTINUE

 180  CONTINUE

 1001 FORMAT (A)
 1002 FORMAT (I3)
 1003 FORMAT (I1)

      END

************************************************************************
* End of DDFORT
************************************************************************
