*CMZ :          21/02/96  14.04.58  by  Hartwig Albrecht
*CMZ :  2.01/01 23/05/95  15.15.44  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   22/05/95

      SUBROUTINE DDFSTM (CSTMT)

************************************************************************
*
* Description: write Fortran statement into CDDCRD
*
* Called from: DD routines
*
* External references:
*
* Argument in/out description
*   CSTMT  in     statement
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"

      INTEGER LENOCC
      CHARACTER CSTMT*(*)

#include "arte/Arte.ff"

      IF (NDDCRD .NE. 1)  CALL MEERRC (13624,
     +  'DDFSTM: previous statement has not been written')

      IF (CSTMT .NE. '+')  THEN

        CDDCRD(1:6) = ' '
        CDDCRD(7:) = CSTMT
        NDDCRD = 8 + LENOCC (CSTMT)

      ELSE

        CDDCRD = '     + '
        NDDCRD = 8

      END IF

      END

************************************************************************
* End of DDFSTM
************************************************************************
