*CMZ :  2.01/01 06/09/95  15.08.16  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   06/09/95

      INTEGER FUNCTION TPLUAR (LUND)

************************************************************************
*
* Description: Convert particle code from Lund to Arte
*              Future: use a fast search algorithm
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   LUND   in     Lund particle code
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/TOPP.fi"

      INTEGER LUND

#include "arte/Arte.ff"
#include "auto/TOPP.ff"

      DO 10 TPLUAR = 1, NTOPP()
        IF (LUND .EQ. ITOPP_LUND(TPLUAR))  GO TO 90
 10   CONTINUE

      TPLUAR = 0

 90   END

************************************************************************
* End of TPLUAR
************************************************************************
