//                              -*- Mode: C++ -*-
//: EFCompareHitCells.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 26/5/97
// Last Update ........
//

#ifndef EFCOMPHITC_HH_
#define EFCOMPHITC_HH_

#include "care/EAMCTruthAnalyzer.hh"
#include "care/ECALtypes.hh"
#include "arte/Arte.hh"
#include "auto/HITC.hh"
#include "auto/MVEX.hh"
#include "auto/MCME.hh"
#include "auto/MTMT.hh"


/**
class  EFCompareHitCells.
  Functor used to compare energy in an Hit Cell
*/

class EFCompareHitCells {
  public:
  /// this is the comparing function: true when p1.Energy > p2.Energy.
  bool operator () ( const int p1, const int p2);
};

#endif // EFCOMPHITC_HH_
