#ifndef _GCAL_HH_
#define _GCAL_HH_
struct GCAL {
   int ncl;
   int sec;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float xmad;
   float ymad;
   float zmad;
   float eff;
   float ms;
   int cmp;
   ArtePointer<GSLX> gesl;
   ArtePointer<GMAX> gmat;
   char gvol[4];
};
#include "auto/GSLX.hh"
#include "auto/GSGC.hh"
#include "auto/GMAX.hh"
#include "auto/GMGC.hh"
#include "auto/GCAL.icc"
#endif
