#ifndef _HITB_HH_
#define _HITB_HH_
struct HITB_RTRA;
struct HITB_MIMP;
struct HITB_DIGB;
struct HITB_RHIT;
struct HITB_RSEG;
struct HITB {
   float z;
   float x;
   float y;
   float q;
   float r;
   int gede;
   ArteRelationPointer<HITB_RTRA> rtra;
   ArteRelationPointer<HITB_MIMP> mimp;
   ArteRelationPointer<HITB_DIGB> digb;
   ArteRelationPointer<HITB_RHIT> rhit;
   ArteRelationPointer<HITB_RSEG> rseg;
};
#include "auto/RTRX.hh"
#include "auto/RTHI.hh"
#include "auto/MIMX.hh"
#include "auto/MIHI.hh"
#include "auto/DIGB.hh"
#include "auto/HIDI.hh"
#include "auto/RHIT.hh"
#include "auto/HIRH.hh"
#include "auto/RSEG.hh"
#include "auto/RSHI.hh"
#include "auto/HITB.icc"
#endif
