#ifndef _NCAL_HH_
#define _NCAL_HH_
struct NCAL {
   int ncl;
   int sec;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float xmad;
   float ymad;
   float zmad;
   float eff;
   float ms;
   int cmp;
   ArtePointer<NSLX> nesl;
   ArtePointer<NMAX> nmat;
   char gvol[4];
};
#include "auto/NSLX.hh"
#include "auto/NSNC.hh"
#include "auto/NMAX.hh"
#include "auto/NMNC.hh"
#include "auto/NCAL.icc"
#endif
