#ifndef _NEDE_HH_
#define _NEDE_HH_
struct NEDE {
   int cmp;
   int lay;
   int sec;
   int shp;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float sxmn;
   float sxmx;
   float symn;
   float symx;
   float cos;
   float sin;
   float rot[9];
   float acc;
   float eff;
   float dod;
   float pit;
   float ms;
   float xfw[4];
   float zfw[4];
   int nwi[4];
   int nsl;
   ArtePointer<NSLX> nesl;
   ArtePointer<NMAX> nmat;
   int nwl;
   int fwl;
   float xmad;
   float ymad;
   float zmad;
   float y1w[4];
   float y2w[4];
   char gvol[4];
   char hwc[12];
   float dedx;
   int gcop;
};
#include "auto/NSLX.hh"
#include "auto/NSND.hh"
#include "auto/NMAX.hh"
#include "auto/NMND.hh"
#include "auto/NEDE.icc"
#endif
