#ifndef _NWAL_HH_
#define _NWAL_HH_
struct NWAL {
   int shp;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float xmad;
   float ymad;
   float zmad;
   float rot[9];
   float ms;
   int nsl;
   ArtePointer<NSLX> nesl;
   ArtePointer<NMAX> nmat;
   int nede;
   char gvol[4];
   float dedx;
};
#include "auto/NSLX.hh"
#include "auto/NSNW.hh"
#include "auto/NMAX.hh"
#include "auto/NMNW.hh"
#include "auto/NWAL.icc"
#endif
