
      SUBROUTINE CRGEPT

************************************************************************
*
* CRGEPT
* written by Siegmund Nowak 08/93
*
* This routine fills the tables GEPT and GEPC from MIMP and MCAL tables 
************************************************************************

      IMPLICIT NONE

      INTEGER I,J,IPL,IPLAST,NZERO,IFILT
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "gean/ZGESL.fi"
#include "arte/ZUTSEL.fi"
      DATA IFILT /65535/           ! equivalent to  /Z0000FFFF/ 
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"

      IF(JMIMP.LE.0 .AND. JMCAL.LE.0 ) GO TO 999

      NZERO = IQ(JGEPT+1)*IQ(JGEPT+2) + 2
      DO I=3,NZERO,2
      IQ(JGEPT+I) = 0
      IQ(JGEPT+I+1) = -1
      ENDDO
      NZERO = IQ(JGEPC+1)*IQ(JGEPC+2) + 2
      DO I=3,NZERO,2
      IQ(JGEPC+I) = 0
      IQ(JGEPC+I+1) = -1
      ENDDO

      IF(JMIMP.LE.0 .OR.NMIMP().EQ.0) GO TO 50

      IPLAST = 0

      DO I=1,NMIMP()
      IPL = IMIMP_GEDE(I)
      IF(IPL.LE.0) GO TO 40
      IF(IPL.GT.NGEDE()) IPL = IAND(IPL,IFILT)  
      IF(IPL.NE.IPLAST) THEN
         IQ(JGEPT -4 + 6*IPL + JGEPT_MIM1) = I
         IPLAST = IPL
      ENDIF
      IQ(JGEPT -4 + 6*IPL + JGEPT_MIML) = I
 40   CONTINUE
      ENDDO

C--   GEPC

 50   IPLAST = 0
      IF(JMCAL.LE.0 ) GO TO 999

      DO I=1,NMCAL()
      IPL = IMCAL_GCAL(I)
      IF(IPL.LE.0) GO TO 60
      IF(IPL.GE.100) IPL = IPL/100
      IF(IPL.NE.IPLAST) THEN
         IQ(JGEPC -4 + 6*IPL + JGEPC_MIM1) = I
         IPLAST = IPL
      ENDIF
      IQ(JGEPC -4 + 6*IPL + JGEPC_MIML) = I
 60   CONTINUE
      ENDDO

 999  RETURN
      END

