*
* $Id: dgptiu.F,v 1.2 1997/12/13 02:38:14 hbcvs Exp $
*
* $Log: dgptiu.F,v $
* Revision 1.2  1997/12/13 02:38:14  hbcvs
* commented line changed
*
* Revision 1.1  1997/10/13 22:48:57  hbcvs
* nw version of high PT digtization
*
c Revision 1.3  1997/05/27  07:20:58  hbcvs
c Changed by Siegmund Nowak to adapt to linux-machines
c
c Revision 1.2  1997/05/16  10:38:12  hbcvs
c  intermediate save of last S.N. changes from cvsdev/ 16.05.97 12-15 for dd-01-05 version
c
* Revision 1.1.1.1  1995/10/24 10:21:25  cernlib
* Geant
*
*
*CMZ :  3.21/04 22/02/95  10.38.36  by  S.Giani
*-- Author :
      SUBROUTINE DGPTIU( ZZZ  , 
     &                   STEP , 
     &                   P    , 
     &                   E    , 
     &                   DEDX , 
     &                   DE   , 
     &                   POTI , 
     &                   POTIL )
************************************************************************
*                                                                      *
* DDDDDDD      GGGGGGGG   PPPPPPPPP   TTTTTTTTTT  IIIIIIII  UU      UU *
* DDDDDDDD    GGGGGGGGGG  PPPPPPPPPP  TTTTTTTTTT  IIIIIIII  UU      UU *
* DD     DD   GG      GG  PP      PP      TT         II     UU      UU *
* DD      DD  GG          PP      PP      TT         II     UU      UU *
* DD      DD  GG          PP      PP      TT         II     UU      UU *
* DD      DD  GG          PPPPPPPPPP      TT         II     UU      UU *
* DD      DD  GG   GGGGG  PPPPPPPPP       TT         II     UU      UU *
* DD      DD  GG   GGGGG  PP              TT         II     UU      UU *
* DD      DD  GG      GG  PP              TT         II     UU      UU *
* DD     DD   GG      GG  PP              TT         II     UU      UU *
* DDDDDDDD    GGGGGGGGGG  PP              TT      IIIIIIII  UUUUUUUUUU *
* DDDDDDD      GGGGGGGG   PP              TT      IIIIIIII   UUUUUUUU  *
*                                                                      *
************************************************************************
*                                                                      *
* This is slightly modified to be used within HERA-B software          *
*  environment routine glandz.F form GEANT 3.21.                       *
* original sources were exported from hydra.ifh.de                     *
* /cern/97a/src/geant321/gphys/glandz.F                                *
*                                                                      *
************************************************************************
*                                                                      *
*  GGGGGGGG   LL        AAAAAAA   NN        NN  DDDDDDD     ZZZZZZZZZZ *
* GGGGGGGGGG  LL       AAAAAAAAA  NNN       NN  DDDDDDDD    ZZZZZZZZZZ *
* GG      GG  LL       AA     AA  NNNN      NN  DD     DD           ZZ *
* GG          LL       AA     AA  NN NN     NN  DD      DD         ZZ  *
* GG          LL       AA     AA  NN  NN    NN  DD      DD        ZZ   *
* GG          LL       AAAAAAAAA  NN   NN   NN  DD      DD       ZZ    *
* GG   GGGGG  LL       AAAAAAAAA  NN    NN  NN  DD      DD      ZZ     *
* GG   GGGGG  LL       AA     AA  NN     NN NN  DD      DD     ZZ      *
* GG      GG  LL       AA     AA  NN      NNNN  DD      DD    ZZ       *
* GG      GG  LL       AA     AA  NN       NNN  DD     DD    ZZ        *
* GGGGGGGGGG  LLLLLLL  AA     AA  NN        NN  DDDDDDDD    ZZZZZZZZZZ *
*  GGGGGGGG   LLLLLLL  AA     AA  NN         N  DDDDDDD     ZZZZZZZZZZ *
*                                                                      *
************************************************************************

C.
C.    ******************************************************************
C.    *                                                                *
C.    *  Energy straggling using a Monte Carlo model.                  *
C.    *  It can be used with or without delta ray generation.          *
C.    *                                                                *
C.    *   It is a NEW VERSION of the model , which reproduces          *
C.    *   the experimental data rather well.                           *
C.    *                                                                *
C.    *  Input : STEP  = current step-length (cm)                      *
C.    *                                                                *
C.    *  Output: DE    = actual energy loss (Gev)                      *
C.    *                 ( NOT the fluctuation DE/DX-<DE/DX> !)         *
C.    *                                                                *
C.    *     ==> Called by : GTELEC,GTHADR,GTMUON                       *
C.    *                                                                *
C.    *  Author      : L.Urban                                         *
C.    *  Date        : 28.04.1988       Last update :  1.02.90         *
C.    *                                                                *
C.    ******************************************************************
C.
      IMPLICIT NONE 

      REAL       Z,ZZZ,STEP,P,E,DEDX,DE,POTI,POTIL
      INTEGER    MAXRND 
      PARAMETER (MAXRND=100)
      REAL      RNDM        ,APOIS           
      INTEGER                         NPOIS
      DIMENSION RNDM(MAXRND),APOIS(3),NPOIS(3),FPOIS(3)
      DOUBLE PRECISION E1,E2,P2,B2,BG2,TM,DEC,W,WW,WWW,RR
      DOUBLE PRECISION X,AK,ALFA,EA,SA,AKL,REALK,FPOIS
      DOUBLE PRECISION ONE,HALF,ZERO
      REAL       HMXINT 
      PARAMETER (HMXINT=2**30)
      PARAMETER (ONE=1,HALF=ONE/2,ZERO=0)
      REAL       RCD     , RCD1       , PROBLM
      PARAMETER (RCD=0.40, RCD1=1.-RCD, PROBLM=0.01)
      REAL       C1  , C2 
      PARAMETER( C1=4, C2=16)

       REAL  F2,F1,E2L,E1L,AMASS,EMASS,CHARGE
       REAL  WL,CSB,APSUM,PROB,E0,EMEAN,EM,RCORR
       REAL  TWOPI,ANC,R,AN,SN,PHI,AVERAG,SIGMA
       INTEGER ITRTYP,NN,I,JPOIS
       PARAMETER(TWOPI=6.2830 )
*
*     ------------------------------------------------------------------
*
*     POTI=1.6E-8*Z**0.9
*     POTIL=LOG(POTI)
*
      CHARGE = SIGN( 1.0 , ZZZ ) 
      Z      = ABS( ZZZ )

      IF(Z.GT.2.) THEN
         F2=2./Z
      ELSE
         F2=0.
      ENDIF
      F1=1.-F2
*
      E2 = 1.E-8*Z*Z
      E2L= LOG(E2)
      E1L= (POTIL-F2*E2L)/F1
      E1 = EXP(E1L)
*
*

      AMASS  = SQRT(ABS(E-P)*(E+P))
      EMASS  = 0.00051099
 
      ITRTYP = 3 
      IF( AMASS .LE. 2.0 * EMASS ) THEN 
       AMASS = EMASS 
       ITRTYP = 2 
      ENDIF 
 
      P2=P*P
      B2=P2/(E*E)
      BG2=P2/(AMASS*AMASS)
      
      IF(ITRTYP.EQ.2) THEN
         TM=P2/(E+EMASS)
         IF(CHARGE.LT.0.) TM=TM/2.
         TM=TM-POTI
         IF(TM.GT.0.0015) TM=0.0015
      ELSE
         TM=EMASS*P2/(0.5*AMASS*AMASS+EMASS*E)
         TM=TM-POTI
         IF(TM.GT.0.0015) TM=0.0015
      ENDIF
*
*
* *** Protection against negative TM    ---------------------
*     TM can be negative only for heavy particles with  a very
*     low kinetic energy (e.g. for proton with T  100-300 kev)
      TM=MAX(TM,ZERO)
*
      W  = TM+POTI
      WW = W/POTI
      WWW= 2.*EMASS*BG2
      WL = LOG(WWW)
      CSB=STEP*RCD1*DEDX/(WL-POTIL-B2)
      APOIS(1)=CSB*F1*(WL-E1L-B2)/E1
      APOIS(2)=CSB*F2*(WL-E2L-B2)/E2
*
      IF(TM.GT.0.) THEN
         APOIS(3)=RCD*DEDX*STEP*TM/(POTI*W*LOG(WW))
      ELSE
         APOIS(1)=APOIS(1)/RCD1
         APOIS(2)=APOIS(2)/RCD1
         APOIS(3)=0.
      ENDIF
*
*    calculate the probability of the zero energy loss
*
      APSUM=APOIS(1)+APOIS(2)+APOIS(3)
      IF(APSUM.LT.0.) THEN
         PROB=1.
      ELSEIF(APSUM.LT.50.) THEN
         PROB=EXP(-APSUM)
      ELSE
         PROB=0.
      ENDIF
*
*
*      do it differently if prob > problm  <====================
      IF(PROB.GT.PROBLM) THEN
         E0=1.E-8
         EMEAN=DEDX*STEP
         IF(TM.LE.0.) THEN
*      excitation only ....
            APOIS(1)=EMEAN/E0
*
            CALL GPOISS(APOIS,NPOIS,1)
            FPOIS(1)=NPOIS(1)
            DE=FPOIS(1)*E0
*
         ELSE
*         ionization only ....
            EM=TM+E0
            APOIS(1)=EMEAN*(EM-E0)/(EM*E0*LOG(EM/E0))
            CALL GPOISS(APOIS,NPOIS,1)
            NN=NPOIS(1)
            DE=0.
*
            IF(NN.GT.0) THEN
               RCORR=1.
               IF(NN.GT.MAXRND) THEN
                  RCORR=FLOAT(NN)/MAXRND
                  NN=MAXRND
*
               ENDIF
               W=(EM-E0)/EM
               CALL GRNDM(RNDM,NN)
               DO 10 I=1,NN
                  DE=DE+E0/(1.-W*RNDM(I))
   10          CONTINUE
               DE=RCORR*DE
*
            ENDIF
         ENDIF
         GOTO 999
      ENDIF
*
      IF(MAX(APOIS(1),APOIS(2),APOIS(3)).LT.HMXINT) THEN
         CALL GPOISS(APOIS,NPOIS,3)
         FPOIS(1)=NPOIS(1)
         FPOIS(2)=NPOIS(2)
         FPOIS(3)=NPOIS(3)
      ELSE
         DO 20 JPOIS=1, 3
            IF(APOIS(JPOIS).LT.HMXINT) THEN
               CALL GPOISS(APOIS(JPOIS),NPOIS(JPOIS),1)
               FPOIS(JPOIS)=NPOIS(JPOIS)
            ELSE
               CALL GRNDM(RNDM,2)
               FPOIS(JPOIS)=ABS(SQRT(-2.*LOG(RNDM(1)*ONE)
     +         *APOIS(JPOIS))*SIN(TWOPI*RNDM(2)*ONE)+APOIS(JPOIS))
            ENDIF
   20    CONTINUE
      ENDIF
 
*
*          Now we have all three numbers in REAL/DOUBLE
*          variables. REALK is actually an INTEGER that now may
*          exceed the machine representation limit for integers.
*
      DE=FPOIS(1)*E1+FPOIS(2)*E2
*
*     smear to avoid peaks in the energy loss (note: E1<<E2)
*
      IF(DE.GT.0.) THEN
         CALL GRNDM(RNDM,1)
         DE=DE+E1*(1.-2.*RNDM(1))
      ENDIF
*
      ALFA=1.
      REALK=0
      DEC=0.
*
      ANC=FPOIS(3)
      IF(ANC.GE.C2) THEN
         R=ANC/(C2+ANC)
         AN=ANC*R
         SN=C1*R
         CALL GRNDM(RNDM,2)
         RR=SQRT(-2.*LOG(RNDM(1)))
         PHI=TWOPI*RNDM(2)
         X=RR*COS(PHI)
         AK=AN+SN*X
         ALFA=WW*(C2+ANC)/(C2*WW+ANC)
         EA=AK*POTI*ALFA*LOG(ALFA)/(ALFA-1.)
         SA=SQRT(ABS(AK*ALFA*POTI*POTI-EA*EA/AK))
         AKL=(EA-C1*SA)/POTI
         IF(AK.LE.AKL) THEN
            X=RR*SIN(PHI)
            DEC=EA+SA*X
            REALK=AK+HALF-MOD(AK+HALF,ONE)
         ELSE
            ALFA=1.
         ENDIF
      ENDIF
      NN=NINT(FPOIS(3)-REALK)
      IF(NN.GT.MAXRND) THEN
         W=1.-ALFA/WW
         WW=POTI*ALFA
*
*     Here we take a gaussian distribution to avoid loosing
*     too much time in computing
*
         AVERAG=-LOG(1.-W)/W
         SIGMA =SQRT(NN*(1./(1.-W)-AVERAG**2))
         CALL GRNDM(RNDM,2)
         DEC   = DEC+WW*(NN*AVERAG+SIGMA*SQRT(-2.*LOG(RNDM(1)))*
     +           SIN(TWOPI*RNDM(2)))
         DE=DE+DEC
      ELSEIF(NN.GT.0) THEN
         W=1.-ALFA/WW
         WW=POTI*ALFA
         CALL GRNDM(RNDM,NN)
         DO 30 I=1,NN
            DEC=DEC+WW/(1.-W*RNDM(I))
   30    CONTINUE
         DE=DE+DEC
      ENDIF
*
  999 CONTINUE 

      END

