#include <iostream.h>
#include <iomanip.h>
 
#include <string>
 
#include <arte/ArteAll.hh>
 
//
// Simple recusrive function which uses the one-to-many relation
// MTRX_ETRA:
//
void printDecayChain(
         ArtePointer<MTRA> mtra,
         unsigned int depth )
{
  string parname(ArtePointer<TOPP>(mtra->topp)->name,6);
 
  cout << setw( depth*12 ) << parname << endl;
  for ( ArteRelationIterator<MTRX_ETRA> out
           (ArtePointer<MTRX>( mtra )->etra);
        out.valid(); out.next() ) {
    printDecayChain( ArtePointer<MTRA>(out), depth+1 );
  }
}
