
      SUBROUTINE CRGCAL(NCL,IVOL,PAR)

************************************************************************
*
* CRGCAL
* written by Siegmund Nowak
*
* This routine books and fills the detector ZEBRA bank
*
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* var1        in           this variable will only be read
*
*
************************************************************************

      IMPLICIT NONE

      INTEGER NN,NCL,IVOL,JVOS,NUMED,NMAT,MATNUM,NMM,LENOCC,JPL,I
      REAL PAR(8)
      CHARACTER MATNAM*20,CNAME*4

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      CALL MMBOOK(JGCAL,1)
      NN = NGCAL()
      IQ(IQGCAL_CMP_L()) = IGESL_CMP(CURRSL)
      CALL MMBREL(JGSGC,CURRSL,NN)

      IF(IGESL_FPL(CURRSL).EQ.0) IQ(IQGESL_FPL(CURRSL)) = NN   
      IQ(IQGESL_NPL(CURRSL)) = IQ(IQGESL_NPL(CURRSL)) + 1
      IQ(IQGCAL_NCL_L()) = NCL
      IQ(IQGCAL_SEC_L()) = NGCAL()

      CALL UCOPY(PAR,Q(QGCAL_XMIN_L()),6)
      
      IQ(HQGCAL_GVOL_L()) = IQ(JVOLUM+IVOL)
      CALL UHTOC(IQ(JVOLUM+IVOL),4,CNAME,4) 
      JVOS = LQ(JVOLUM-IVOL)
      NUMED = Q(JVOS+4)
      NMAT = Q(LQ(JTMED-NUMED)+6)
      CALL UHTOC(Q(LQ(JMATE-NMAT)+1),4,MATNAM,20)
      NMM = MATNUM(MATNAM(1:LENOCC(MATNAM)))
      CALL MMBREL(JGMGC,NMM,NN)
      IF(IDEBUG.NE.0) THEN
        JPL   = JGCAL + (2-NCGCAL()) + NGCAL()*NCGCAL()
        WRITE(LPRNT,101) IQ(JGCAL+2),(Q(JPL+JGCAL_XMIN+I),I=0,5),CNAME
      ENDIF
      RETURN
 101  FORMAT(1X,'CAL ',I4,6(1X,F7.2),'  ',A4)
      END

