      SUBROUTINE CRLOSH(BFMCL,BFMCS)

************************************************************************
*
* written by Siegmund Nowak
*
* This routines gives out whether the short or the long version of a 
* detector geometry is set 
*
*       called from 
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* BFMCL bit(LGESL_...) = 1   long version is set
* BFMCS bit(LGESL_...) = 1   short version is set
************************************************************************

      IMPLICIT NONE

      INTEGER I,BFMCL,BFMCS
#include "arte/Arte.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"

#include "arte/Arte.ff"

      IF(NDETV.GT.32) CALL MEERRO('CRLOSH: NDETV > 32')
      DO 10 I=1,NDETV
      CALL SBIT0(BFMCL,I)
      CALL SBIT0(BFMCS,I)
      IF(DETV(I)(4:4).EQ.'L') THEN
         CALL SBIT1(BFMCL,I)
         GO TO 10 
      ELSE IF(DETV(I)(4:4).EQ.'S') THEN
         CALL SBIT1(BFMCS,I)
      ENDIF
 10   CONTINUE

 999  RETURN
      END

************************   END    GEOACT    *****************************











