*-- Author :    Siegmund Nowak   30/12/94
************************************************************************
*
* GRADLN
* written by Siegmund Nowak, 30/12/94 10.45.29
*
* This routine calculates the radition length XMS for a material with
* volumen number IVO
*
*       called from geometry routines
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* IVOL       in           Geant volumen number
* XMS        out          Radiation length
************************************************************************

      SUBROUTINE GRADLN(IVO,XMS)
C------------------------------

      IMPLICIT NONE
#include "arte/Arte.fi"
#include "gean/gclink.fi"
      INTEGER IVO,JVO,IMED,JTM,IMAT,JMA
      REAL XMS
#include "arte/Arte.ff"

      JVO = LQ(JVOLUM-IVO)
      IMED = Q(JVO+4)
      JTM = LQ(JTMED-IMED)
      IMAT = Q(JTM+6)
      JMA = LQ(JMATE-IMAT)
      XMS = Q(JMA+9)

      RETURN
      END


