
      SUBROUTINE HGCONS

************************************************************************
*
* written by Siegmund Nowak 97/03/20
*
* This routine defines default values for HBGEAN constants
*
* called from HGINIT
************************************************************************

      IMPLICIT NONE

      REAL ANGSPR
      COMMON /ZGSPRL/ ANGSPR
      INTEGER TURBFL
      COMMON /TURB/ TURBFL
#include "gean/gcphys.fi"
#include "gean/gctmed.fi"
#include "gean/ZGBEAM.fi"

c     the default value will be 
      ILOSS = 1

c     maximal rotation angle for spiraling particles
      ANGSPR = 94.25                     ! 30*pi

c     switch for fast muon tracing
      TURBFL = 0 

c     Cerenkov photon generation will be switched on by default
      ITCKOV = 1

c     time spread of primary vertex will be switched off by default
      TIME_SWIT = 0
       
      RETURN
      END




