
*-- Author :    B.Fominykh 28/06/96
*
      SUBROUTINE  MUSHIL(J)
C     =====================
C     Muon Detector Shield
*  J - muon superlayer number
*
      IMPLICIT NONE
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGMUON.fi"
      INTEGER I,J,L,IVOL, MEDNUM
      INTEGER IPB,NBL,IB,IPP
      REAL PAR(3), ZPOSM
      REAL X_POS, Y_POS, Z_POS
* ---------------------------
#include "arte/Arte.ff"
#include "auto/GEO.ff"
* trap
      IF(J.LT.1.OR.J.GT.6) GOTO 6
* definition of volumes
      IF(J.EQ.1) THEN
* iron shield
        CALL GSVOLU('MUFE','BOX ',MEDNUM(1,'IRON_MU') ,PAR,0,IVOL)
        CALL GSATT('MUFE','COLO',20)
* shield made of concrete-iron mixture
        CALL GSVOLU('MUFB','BOX ',MEDNUM(1,'MUON_CONCRET') ,PAR,0,IVOL)
        CALL GSATT('MUFB','COLO',40)
      ENDIF
* Z-position of volume MUON
      ZPOSM=.5*(FGESL_Z1(MUONSL)+FGESL_Z2(MUONSL)) 
* loops over shield layers
      IF(NLMUF(J).LE.0) GOTO 6
      DO 5 L=1,NLMUF(J)
* number of absorber blocks in the layer
        IPB=4*(J-1)+L
        NBL=NAMUF(IPB)
        IF(NBL.LE.0) GOTO 5
        Z_POS = -ZPOSM + ZAMUF(J) + .5*DZMUF(IPB)
        IF(L.GT.1) THEN
          DO I=1,L-1
            Z_POS=Z_POS+DZMUF(4*(J-1)+I)
          ENDDO
        ENDIF
* loops over ansorber blocks in the layer
        DO 4 IB=1,NBL
* pointer to block parameters
          IPP=NSHIMX*(IPB-1)+IB
          PAR(1) = .5*DXMUF(IPP)
          PAR(2) = .5*DYMUF(IPP)
          PAR(3) = .5*DZMUF(IPB)
          X_POS = XAMUF(IPP)+.5*DXMUF(IPP)
          Y_POS = YAMUF(IPP)+.5*DYMUF(IPP)
          IF(NMMUF(IPP).EQ.1) THEN
*           absorbtion block made of iron            
            CALL CRPOS('MUFE','MUON',0,0,X_POS,Y_POS,Z_POS,0,'MANY',PAR)
          ELSEIF(NMMUF(IPP).EQ.2) THEN
*           absorbtion block made of beton-iron mixture
            CALL CRPOS('MUFB','MUON',0,0,X_POS,Y_POS,Z_POS,0,'MANY',PAR)   
          ENDIF
 4      CONTINUE
 5    CONTINUE
*
 6    CONTINUE
      RETURN
      END


