// utfilp.C (name, subdir)
// written by Siegmund Nowak 97/11/18
// This routine opens a file either from the PWD, from a subdirectory 
// of the PWD with the same name as in the standard geo , from a given  
// subdirectory (second parameter in the call) or from $HB/$HBVERS/geo
// The search is in the order descibed above. The file is positioned at 
// the begin, a message is written out and the filepointer is given 
// as return value. In the calling program the routine must be declared as 
// FILE *utfilp(char*,char*) 
// name:   filename          
// subdir: subdirectory from where the filename should be taken (it is 
//         assumed that subdir is a replacement of $HB/$HBVER and that the 
//         remaining structure is the same as in $HB/$HBVERS)    

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include "arte/Arte.hh"
#include "arte/ArteMessage.hh"


FILE *filepointer;
char fname[256],buffer[256];
char *slbuf, *ptr;

  FILE *utfilp(char* name, char* subdir){ 

  strcpy(fname,name);
  strcpy(buffer,"\n");
  ptr=strtok(fname,"/");
  while (ptr != NULL) 
    strcpy(buffer,ptr), ptr = strtok(NULL,"/");
  if(strlen(buffer) != 0) {
    strcpy(fname,buffer);
    filepointer=fopen(fname,"r");
    if(filepointer){ 
       arteMsg <<"OPEN FILE " << fname  ;
       arteMsg.warn();          
       fseek(filepointer,0L,0);
       return filepointer;}     }                          

  strcpy(fname,name);
  filepointer=fopen(fname,"r");
  if(filepointer) {
       arteMsg <<"OPEN FILE " << fname  ;
       arteMsg.warn();
     fseek(filepointer,0L,0);
     return filepointer;}                               

  
  if(strlen(subdir) > 0) {
  strcpy(fname,subdir); 
  strcat(buffer,"/geo/");  
  strcat(buffer,fname); 
  filepointer=fopen(fname,"r");
  if(filepointer) {
       arteMsg <<"OPEN FILE " << fname  ;
       arteMsg.warn();          
     fseek(filepointer,0L,0);
     return filepointer;}  }                              

  strcpy(fname,name); 
  slbuf = getenv("HB");
  strcpy(buffer,slbuf);
  strcat(buffer,"/");
  slbuf = getenv("HBVERS");
  strcat(buffer,slbuf);
  strcat(buffer,"/geo/");  
  strcat(buffer,fname);
  strcpy(fname,buffer);
  filepointer=fopen(fname,"r"); 
  if(filepointer) {
     arteMsg <<"OPEN FILE " << fname  ;
     arteMsg.warn();          
     fseek(filepointer,0L,0);
     return filepointer;}                               

  arteMsg <<"Can not open " << name  ;
  arteMsg.error();          
  return filepointer;                               }


