*CMZ :  0.01/02 22/08/94  12.18.25  by  Dominik Ressing
*CMZ :  0.01/01 22/07/94  15.02.06  by  Dominik Ressing
*-- Author :    Dominik Ressing   18/07/94
************************************************************************************
*
* L1MESCO
* written by Dominik Ressing, 20/07/94 19.08.35
*
* This routines action:
* Connect a message: connect message ipoint after message iprev in its queue
*
* Variables   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------------------
* ipoint        in         pointer to new message
* iprev         in         pointer to message after which the new one is to connect
*
************************************************************************************
c
      SUBROUTINE L1MESCO(ipoint,iprev)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
c
      INTEGER inext,iprev,ipoint
c
c     --- the two messages may be the same !! (then its at the right place)
      IF ( ipoint.eq.iprev) RETURN
c
c     --- find next message:
      inext = L1MEstor(iprev+L1MEnext)
c     --- connect message inbetween previous and next message
      L1MEstor(ipoint+L1MEnext) = inext
      L1MEstor(ipoint+L1MEprev) = iprev
c     --- set forward pointer from previous
      L1MEstor(iprev+L1MEnext)  = ipoint
c     --- set backward pointer from next message
      IF ( inext.gt.0 ) L1MEstor(inext+L1MEprev) = ipoint
c
      RETURN
c
      END
