*CMZ :  2.01/01 23/06/95  18.38.17  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   19/05/95

      SUBROUTINE LIDDEF (CTPL)

************************************************************************
*
* Description: list data definition table
*
* Called from: KUIP etc.
*
* External references:
*
* Argument in/out description
*   CTPL   in     terminal/printer/log_file flag
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDCOM.fi"

      INTEGER IR
      CHARACTER *(*) CTPL

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IF (JDDEF .EQ. 0)  GO TO 80
      IF (NDDEF() .EQ. 0)  GO TO 80

      DO 10 IR = 1, NDDEF()
        IF (IDDEF_FLAG(IR) .GE. 0)  CALL LIDDE0 (IR, CTPL)
        IF (IR .EQ. NDDUSR)  CALL MESELP
     +   ('* end of user DD commands', CTPL)
        IF (IR .EQ. NDDNEW)  CALL MESELP
     +   ('* end of new DD commands', CTPL)
 10   CONTINUE

      GO TO 90

 80   CALL MEWARC (7625, 'LIDDEF: data definition table empty')

 90   END

************************************************************************
* End of LIDDEF
************************************************************************
