*CMZ :  2.01/01 30/11/95  16.20.59  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE LITIME (CTPL)
************************************************************************
*
* Description: list timing information
*
* Called from: anywhere
*
* External references:
*
* Arguments: in/out description
*   CTPL    in      printer destination
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"

      REAL T
      CHARACTER *(*) CTPL

#include "arte/Arte.ff"

      C78 = '=== Time job:'
      CALL TIMEX (T)
      CALL CH78BF (T, 3)
      IF (PROGSTAT .GE. 0)  THEN
        CALL CH78BC ('init')
        CALL CH78BF (TIMEINIT, 3)
      END IF
      IF (PROGSTAT .GT. 0)  THEN
        CALL CH78BC ('termin:')
        CALL TIMEX (T)
        CALL CH78BF (T - TIMESTOP, 3)
      END IF
      CALL CH78BC ('remaining:')
      CALL TIMEL (T)
      CALL CH78BF (T, 3)
      CALL ME78SP (CTPL)

      IF (NEVENTS .LE. 0)  GO TO 90
      C78 = '=== Time events total:'
      T = TIMESTOP - TIMEINIT
      CALL CH78BF (T, 3)
      CALL CH78BC ('aver:')
      CALL CH78BF (T / NEVENTS, 3)
      CALL CH78BC ('max:')
      CALL CH78BF (TIMEEMAX, 3)
      CALL ME78SP (CTPL)

 90   END

************************************************************************
* End of LITIME
************************************************************************
