*CMZ :  2.01/01 14/11/95  20.37.51  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   05/04/95

      SUBROUTINE LIZEBR (I1, I2, CTPL)

************************************************************************
*
* Description: List Q/IQ
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*  I1      in     Q(I1) ...
*  I2      in     ... Q(I2) will be listed on printers
*  CTPL    in     combination of 'T','P','L'
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"

      INTEGER I, I1, I2, J, JL
      CHARACTER CTPL*(*), C4*4, C16*16

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      IF (I1 .LT. -8 .OR. I2 .GT. NZEBRA)  THEN
        C78 = 'LIZEBR: indices'
        CALL CH78BI (I1)
        CALL CH78CI (I2)
        CALL CH78BC ('must be between 0 and')
        CALL CH78BI (NZEBRA)
        CALL ME78WC (3524587)
        GO TO 90
      END IF

      DO 40 I = I1, I2
        C78 = ' '
        DO 10 J = 1, NARLNK
          IF (JLINK(J) .EQ. 0)  GO TO 10
          IF (I .LT. JLINK(J) - 8 .OR.
     +      I .GT. JLINK(J) + IQ(JLINK(J)-1))  GO TO 10
          JL = I - JLINK(J)
          IF (HMEMO_NAME(J) .NE. HBLANKSP)  THEN
            CALL CHHTOC (IQ(HQMEMO_NAME(J)), C78(1:4))
          ELSE
            C78 = 'Unknown bank; address:'
            CALL CH78BI (J)
          END IF
          CALL CH78BI (JL)
          IF (JL .GT. 2 .AND.
     +      IQ(JLINK(J)+1) * IQ(JLINK(J)+2) .LT. IQ(JLINK(J)-1) .AND.
     +      JL .LE. IQ(JLINK(J)+1) * IQ(JLINK(J)+2) + 2)  THEN
            CALL CH78BC ('c')
            CALL CH78BI (MOD (JL - 3, IQ(JLINK(J)+1)) + 1)
            CALL CH78BC ('r')
            CALL CH78BI ((JL - 3) / IQ(JLINK(J)+1) + 1)
          END IF
          GO TO 20
 10     CONTINUE
 20     CALL CH78BI (I)
        CALL CHRIGH (C78(1:30))
        IF (IQ(I) .LT. -8388608 .OR. IQ(I) .GE. 0)  THEN
          WRITE (C16, '(G16.6)')  Q(I)
        ELSE IF (IQ(I) .EQ. -8388608)  THEN
          C16 = ' INFINITY'
        ELSE
          C16 = ' NAN'
        END IF
        WRITE (C78(32:),1001) IQ(I), C16, IQ(I)
        CALL CHHTOC (IQ(I), C4)
        DO 30 J = 1, 4
 30     IF (C4(J:J) .EQ. CHLINEF .OR. C4(J:J) .EQ. CHVERTT .OR.
     +      C4(J:J) .EQ. CHFORMF .OR. C4(J:J) .EQ. CHCARRR)
     +    C4(J:J) = ' '
        CALL CH78BC (C4)
        CALL ME78SP (CTPL)
 40   CONTINUE

 1001 FORMAT (I11,A,1X,Z8)

 90   END

************************************************************************
* End of LIZEBR
************************************************************************
