*CMZ :  4.06/02 19/10/96  15.23.20  by  Rainer Mankel
*CMZ :  4.05/00 14/04/96  14.31.15  by  Rainer Mankel
*-- Author :    Rainer Mankel   14/04/96

      subroutine prgcal()

*     **** print gcal information
      implicit none
      integer id1, id2, nch, gcal1, gcal2, gc, nprint
      character*80 chopt
#include "arte/Arte.fi"

#include "auto/GEO.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"

*     **** parameters
      call kugeti(id1)
      call kugeti(id2)
      call kugetc(chopt,nch)

*     **** fixup
      if (jgcal.le.0) then
         call mewarn('prgcal: table GCAL is not booked')
         go to 999
      endif
      if (jgepc.le.0) then
         call mewarn('prgcal: table GEPC is not booked')
         go to 999
      endif

      if (id2.eq.0.and.id1.ne.0) id2 = id1
      id1 = max(id1,1)
      if (id2.eq.0) then
       id2 = ngcal()
      else
       id2 = min(id2,ngcal())
      endif

*     **** loop over gcal range
      nprint = 0
      gcal1 = max(id1,1)
      gcal2 = min(id2,ngcal())
      do 10 gc=gcal1,gcal2
         if (index(chopt,'B').gt.0) then ! borders
            if (mod(nprint,20).eq.0) then ! headline
               print 112,'gcal','ncl',
     +              'xmi','xma','ymi','yma','zmi','zma'
            endif
            print 111,gc,igcal_ncl(gc),
     +           fgcal_xmin(gc), fgcal_xmax(gc),
     +           fgcal_ymin(gc), fgcal_ymax(gc), fgcal_zmin(gc),
     +           fgcal_zmax(gc)
 111        format(2i5,6f8.2)
 112        format(2a5,6a8  )
         elseif (index(chopt,'G').gt.0) then ! GEPC info
            if (mod(nprint,20).eq.0) then ! headline
               print 122,'gcal','hit1','hitl',
     +              'dig1','digl','mim1','miml'
            endif
            print 121,gc,
     +           igepc_hit1(gc), igepc_hitl(gc),
     +           igepc_dig1(gc), igepc_digl(gc),
     +           igepc_mim1(gc), igepc_miml(gc)
 121        format(i5,6i6)
 122        format(a5,6a6)
         else
            if (mod(nprint,20).eq.0) then ! headline
               print 102,'gcal','ncl','sec','eff','ms','cmp','gesl'
            endif
            print 101,gc,
     +           igcal_ncl(gc),igcal_sec(gc),
     +           fgcal_eff(gc),fgcal_ms(gc),igcal_cmp(gc),ogcal_gesl(gc)
 101        format(3i5,f5.3,e12.4,2i5)
 102        format(3a5,a5,  a12  ,2a5)
         endif
         nprint = nprint + 1
 10   continue
 999  end

