#ifndef _RCTUPLE_H_
#define _RCTUPLE_H_
//----------------------------------------------------------------------
// Created: 15.08.97  by   Olya Igonkina

// common blocks for ntuples

//----------------------------------------------------------------------

#include <CLHEP/Utilities/fortran.h>

extern "C" 
{
  BEGIN_FORTRAN_COMMON( matchnt)
    int  Nevt;
    int  Nleft;
    int  Nright;
    int  Nmatch;
    int  Nbad; 
    int  Nlost;
    int  Nreal;    
    float Rbad;
    float Rlost;
    int   fromJpsi;
  END_FORTRAN_COMMON(   matchnt)
}

extern "C" 
{
  BEGIN_FORTRAN_COMMON( deltas)
    int   flag;
    float deltaX;
    float deltaY;
    float  deltaTX;
    float  deltaTY;
    float  deltaPE;
    float  chi2;
    int ipart1;
    int ipart2;
    int imoth1;
    int imoth2;
  END_FORTRAN_COMMON(   deltas)
}

#endif
