*-- Author :    Rainer Mankel   10/11/93

      subroutine diaxis(chopt)

*     **** display axes in current plot
      implicit none
#include "pris/zgraf.fi"
      real rval(10), x0, x1, y0, y1
      real xwi1zg, xwi2zg, ywi1zg, ywi2zg, ywi3zg, ywi4zg
      character*(*) chopt
      character*1 cxaxis, cyaxis

      if (.not.((iviewzg.ge.0.and.iviewzg.le.2).or.iviewzg.ge.7))
     +      go to 999

      call iselnt(nt_framzg)

*     **** inquire current NT
      call igqwk(1,'NTNB',rval)

**      print *,' current nt=',rval(1)

*     **** inquire window
      call igqwk(1,'NTWN',rval)

**      print *,' current window: ',(rval(ii),ii=1,4)

*     **** color
      call igset('PLCI',1.)
      call igset('TXCI',cotxtzg)

      xwi1zg = xminzg + 6. * uxzg
      xwi2zg = xmaxzg - 6. * uxzg
      ywi1zg = yminzg + 6. * uyzg
      ywi2zg = ymaxzg - 8. * uyzg
      ywi3zg = ywi2zg - 6. * uyzg
      ywi4zg = ymaxzg - 6. * uyzg

*     **** background color box
      call igset('FACI',0.)
      call igset('FAIS',1.)
*     **** space for x labels
      call igset('BORD',0.)
      call igbox(xminzg,xmaxzg,yminzg,ywi1zg)
*     **** space for y labels
      call igbox(xminzg,xwi1zg,yminzg,ymaxzg)

      if ((iviewzg.ge.0.and.iviewzg.le.2).or.iviewzg.ge.7) then
       call igset('LAOF',2.*uxzg)
       call istxfp(0,2)
*      **** x axis
       call igaxis(xwi1zg,xwi2zg,ywi1zg,ywi1zg,
     +             xwi1zg,xwi2zg,10,'+D')
       call igset('LAOF',0.02*(y1-y0))
*      **** y axis
       if (lheaderzg) then
        call igaxis(xwi1zg,xwi1zg,ywi1zg,ywi2zg,
     +              ywi1zg,ywi2zg, 8,'-D')
       else
        call igaxis(xwi1zg,xwi1zg,ywi1zg,ymaxzg,
     +              ywi1zg,ymaxzg, 8,'-D')
       endif

*     **** generate axis text
      if (iviewzg.eq.0) then
       cxaxis = 'X'
       cyaxis = 'Y'
      elseif (iviewzg.eq.1) then
       cxaxis = 'Z'
       cyaxis = 'X'
      elseif (iviewzg.eq.2) then
       cxaxis = 'Z'
       cyaxis = 'Y'
      elseif (iviewzg.eq.7) then
       cxaxis = 'Z'
       cyaxis = 'U'
      elseif (iviewzg.eq.8) then
       cxaxis = 'Z'
       cyaxis = 'V'
      elseif (iviewzg.eq.9) then
       cxaxis = 'Z'
       cyaxis = 'PHI'
      elseif (iviewzg.eq.10) then
       cxaxis = 'Z'
       cyaxis = 'LGP'
      else
       cxaxis = ' '
       cyaxis = ' '
      endif

*     **** plot x-axis text
      if (cxaxis.ne.' ') then
       x0 = xwi2zg
       x1 = xmaxzg
       y0 = yminzg
       y1 = ywi1zg
       call igset('FACI',0.)
       call igset('PLCI',1.)
       call igset('LWID',5.)
       call igset('BORD',1.)
       call igbox(x0,x1,y0,y1)
       call istxfp(0,2)
       call igset('TXAL',23.)
       call ischh(2.*uyzg)
       call igset('PASS',3.)
       call igset('TXCI',cotxtzg)
       call itx(0.5*(x0+x1),0.5*(y0+y1),cxaxis)

      endif

*     **** plot y-axis text
      if (cyaxis.ne.' ') then

       x0 = xminzg
       x1 = xwi1zg

       if (lheaderzg) then
        y0 = ywi3zg
        y1 = ywi2zg
       else
        y0 = ywi4zg
        y1 = ymaxzg
       endif

       call igset('FACI',0.)
       call igset('PLCI',1.)
       call igset('LWID',5.)
       call igset('BORD',1.)
       call igbox(x0,x1,y0,y1)
       call istxfp(0,2)
       call igset('TXAL',23.)
       call ischh(2.*uyzg)
       call igset('PASS',3.)
       call igset('TXCI',cotxtzg)
       call itx(0.5*(x0+x1),0.5*(y0+y1),cyaxis)
      endif

      call igset('BORD',0.)
**       call igset('LWID',1.)
      endif

 999  end

