*CMZ :  4.06/02 19/10/96  15.42.15  by  Rainer Mankel
*CMZ :  4.05/03 30/05/96  17.49.09  by  Rainer Mankel
*CMZ :  4.05/00 12/04/96  13.28.23  by  Rainer Mankel
*-- Author :    Rainer Mankel   02/04/96

      subroutine dihitc(sl,hitc,idmc,chopt)

*     **** display ECAL hits
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"

#include "auto/GEO.fi"
#include "auto/HITC.fi"
#include "auto/MCAL.fi"

      character*(*) chopt
      real xxx(5), yyy(5), wc(3), zb, dx, dy, e, col
      integer sl, hitc, idmc, hc1, hc2, hc, block, cell, ii, j, ialia,
     +     jauxmi, mcal, mtra, xsig(4), ysig(4), gcce, igcal

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITC.ff"
#include "auto/MCAL.ff"

      data xsig /-1, +1, +1, -1/, ysig /-1, -1, +1, +1/

      if (hitc.gt.0) then
         hc1 = hitc
         hc2 = hitc
      else
         hc1 = 1
         hc2 = nhitc()
      endif

      do 10 hc=hc1,hc2          ! loop over ECAL hits

         if (sl.gt.0) then      ! check SL
            if (ogcal_gesl(igcce_ceid(ihitc_gcce(hc))/100).ne.sl) 
     +             go to 10
         endif

         if (idmc.ne.0) then    ! check associated mtra
            do 20 ialia=1,99
               if (ialia.eq.1) then
                  jauxmi = phitc_mcal(hc)
               else
                  jauxmi = xhitc_mcal(jauxmi)
               endif
               if (jauxmi.gt.0) then
                  mcal = mhitc_mcal(jauxmi)
                  mtra = omcal_mtra(mcal)
                  if (mtra.eq.idmc) go to 22
               else
                  go to 10      ! search ended without related mcal
               endif
 20         continue
            go to 10
 22         continue            ! hitc related to mtra found
         endif

         wc(1) = fhitc_x(hc)
         wc(2) = fhitc_y(hc)
	 gcce = ihitc_gcce(hc)
	 igcal = igcce_ceid(gcce)
         block = igcal / 100
         cell = mod(igcal,100)
         if (block.ge.1.and.block.le.ngcal()) then
            zb = fgcal_zmin(block)
         else
            print *,' () dihitc: block out of range, ', block
            zb = 1500.
         endif
         wc(3) = zb

         dx = (fgcal_xmax(block) - fgcal_xmin(block)) / igcal_ncl(block)
         dy = (fgcal_ymax(block) - fgcal_ymin(block)) / igcal_ncl(block)

         do ii=1,4
            wc(1) = fhitc_x(hc) + xsig(ii) * 0.5 * dx
            wc(2) = fhitc_y(hc) + ysig(ii) * 0.5 * dy
            wc(3) = zb
            call dipro(wc,xxx(ii),yyy(ii))
         enddo
         xxx(5) = xxx(1)
         yyy(5) = yyy(1)

         e = fhitc_q(hc)
         if (e.gt.0.01) then
            j = alog(e) / alog(3.)
            if (j.le.-2) then
               col = coca1zg
            elseif (j.eq.-1) then
               col = coca2zg
            elseif (j.eq.0) then
               col = coca3zg
            elseif (j.eq.1) then
               col = coca4zg
            else
               col = coca5zg
            endif
            call igset('FAIS',1.)
            call igset('FACI',col) !
            call ifa(5,xxx,yyy)
**            call igset('PLCI',1.)
**            call ipl(5,xxx,yyy)
         endif
 10   continue

      end

