*CMZ :  4.02/00 19/07/96  13.56.46  by  Rainer Mankel
*CMZ :  4.00/01 13/07/95  15.30.36  by  Rainer Mankel
*CMZ :  4.00/00 18/05/95  09.35.36  by  Rainer Mankel
*CMZ :  3.04/01 07/02/95  14.00.27  by  Rainer Mankel
*CMZ :  3.03/01 19/01/95  17.36.38  by  Rainer Mankel
*CMZ :  3.01/00 26/10/94  18.58.24  by  Rainer Mankel
*-- Author :    Rainer Mankel   26/10/94

      subroutine tflobr(ipl,x_local,e_local,iih1,iih2)

*     **** locate the bricks and hits suitable for plane ipl
      implicit none
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "rang/zbric.fi"
      double precision x_local, e_local
      real dpred, dstraw, dzshft, dreso, dtotal, rstraw
      integer ibrick1, ibrick2, jbrick1, jbrick2, iih1, iih2
      integer ibricka, ibrickb, ipl
*     **** still crude
      parameter (rstraw=0.5)
#include "arte/Arte.ff"
#include "auto/GEO.ff"

*     **** init output
      iih1 = 0
      iih2 = 0

      if (igede_cmp(ipl).ge.1.and.igede_cmp(ipl).le.3) then
      else
       print *,' () tflobr: invalid cmp for ipl=',ipl
       stop 'tflobr'
      endif

*     **** prediction margin
      dpred = e_local

*     **** straw diameter margin
      if (igede_cmp(ipl).eq.2) then
       dstraw = 1.42 * rstraw
      else
       dstraw = 0.
      endif

*     **** z shift margin
      dzshft = 0.

*     **** resolution margin
      if (igede_cmp(ipl).eq.2) then
       dreso = 0.
      elseif (igede_cmp(ipl).eq.1) then
       dreso = 5 * 0.0020
      else
       dreso = 5 * 0.0060
      endif

*     **** total margin
      dtotal = dpred + dstraw + dzshft + dreso

*     **** find bricks
      if (deltbr(ipl).eq.0.) then
       print *,' () tflobr: ipl, deltbr(ipl)=',
     +                      ipl, deltbr(ipl)
      endif
      ibricka = (x_local - dtotal - uminbr(ipl))
     +                                          / deltbr(ipl) + 1.
      ibrickb = (x_local + dtotal - uminbr(ipl))
     +                                          / deltbr(ipl) + 1.

      ibrick1 = min(ibricka,ibrickb)
      ibrick2 = max(ibricka,ibrickb)

      ibrick1 = max(ibrick1,1)
      ibrick2 = min(ibrick2,nbplbr(ipl))

      if (ibrick2.le.0)       go to 999
      if (ibrick2.lt.ibrick1) go to 999

*     **** find range of hits
      jbrick1 = ibplbr(ipl)+ibrick1
      jbrick2 = ibplbr(ipl)+ibrick2

 20   if (nhitbr(jbrick1).gt.0) go to 21
*     **** skip empty brick
      if (jbrick1.lt.jbrick2) then
       jbrick1 = jbrick1 + 1
       go to 20
      else
       go to 999
      endif
 21   continue

 30   if (nhitbr(jbrick2).gt.0) go to 31
*     **** skip empty brick
      if (jbrick1.lt.jbrick2) then
       jbrick2 = jbrick2 - 1
       go to 30
      else
       go to 999
      endif
 31   continue

      iih1 = ihitbr(jbrick1)
      iih2 = ihitbr(jbrick2) + nhitbr(jbrick2)

 999  end




