*CMZ :  4.02/00 19/07/96  13.56.49  by  Rainer Mankel
*-- Author :    Rainer Mankel   17/04/96

      subroutine tftriref(dom,maxref,nref,vecref)

*     **** get reference tracks for triplets
      implicit none
#include "rang/zdomain.fi"


      integer dom,              ! domain
     +     maxref,              ! length of array vecref
     +     nref,                ! returned # ref tracks
     +     vecref(maxref)       ! vector of reference tracks

      integer maxmc
      parameter (maxmc=50000)
      integer countmc(maxmc)

      integer ii,win,lay,ilay,iih,idh,hitb,mc,sig
      real ptot
#include "arte/Arte.fi"
#include "auto/MTRA.fi"
#include "arte/Arte.ff"
#include "auto/MTRA.ff"

      do ii=1,maxmc             ! reset mc counters
         countmc(ii) = 0
      enddo

      do win=win1_dm(dom),win1_dm(dom)+nwin_dm(dom)-1
     +                          ! loop over domain windows
         do ilay=1,99           ! loop over 0-deg layers
            if (ilay.eq.1) then
               lay = layer1_dw(2,win)
            else
               lay = nxtlay_dl(2,lay)
            endif
            if (lay.gt.0) then
               do 10 iih=1,9999    ! loop over hits in layer
                  if (iih.eq.1) then
                     idh = hit1_dp(lay)
                  else
                     idh = nxthit_dh(idh)
                  endif

                  if (idh.le.0) go to 11
                  hitb = hitb_dh(idh)

                  call tfmcown(hitb,mc,sig)
                  if (mc.le.0) go to 10
                  if (mc.le.maxmc) then
                     countmc(mc) = countmc(mc) + 1
                  else
                     print *,' () tftriref: overflowing ',
     +                    ' mc=', mc
                  endif
 10            continue
 11            continue
            endif
         enddo ! layers
      enddo ! win

      nref = 0
      do 20 ii=1,min0(maxmc,iq(jmtra+2))
         ptot = sqrt( fmtra_px(ii)**2 + fmtra_py(ii)**2
     +        + fmtra_pz(ii)**2 )
         if (ptot.lt.5.) go to 20
         if (abs(fmtra_pz(ii)).lt.1.) go to 20
         if (abs(fmtra_px(ii)/fmtra_pz(ii)).gt.0.9) go to 20
         if (abs(fmtra_py(ii)/fmtra_pz(ii)).gt.0.9) go to 20
         if (countmc(ii).ge.4) then
            if (nref.lt.maxref) then
               nref = nref + 1
               vecref(nref) = ii
               print *,' ref,mc,#hits=',nref,ii,countmc(ii)
            else
               print *,' () tftriref: too many ref=', nref
            endif
         endif
 20   continue
      print *,' tftriref: # ref tracks=', nref

      end


