*CMZ :  1.04/07 15/08/95  12.01.09  by  joerg f. rieling
*-- Author :
c------------------------------------------------------------------------------
c	Subroutine SCHIPROB berechnet den  Konfidenzlevel i. A. von Chi^2
c	und Zahl d. Freiheitsgrade
c------------------------------------------------------------------------------
	subroutine SCHIPROB (CHI2, FREIH_GR, KONF_LVL)

	implicit none

	intrinsic exp, sqrt, float, amax1
	external  ERFC

c----------------- Input - Variablen -----
	real    CHI2
	integer FREIH_GR

c----------------- Output - Variablen -----
	real    KONF_LVL

c----------------- Sonstiges -----
	real    Y, V, FAC, SUM, TERM, SRTY
	integer N, I, IL
	real    ERFC

	Y = CHI2
	N = FREIH_GR

	if (N.le.0 .or. Y.lt.0) then
	   V = 1.
	else if (N .gt. 100) then
	   V = .5 * ERFC (sqrt(Y) - sqrt(float(N) - .5))
	else

           if (mod(N, 2) .eq. 0) then
	      V    = 0.
	      FAC  = 1.	
	      IL   = 2
	   else
	      SRTY = sqrt (.5 * Y)
	      V    = ERFC(SRTY)
	      if (N .eq. 1) goto 500
	      FAC  = 1.1283792 * SRTY
	      IL   = 3
	   end if
	   SUM     = 0.
	   TERM    = 1.
	   do I = IL, N, 2
              SUM  = SUM + TERM
	      TERM = TERM * Y / float (I)
	   end do ! I
	   V = V + FAC * SUM * exp (-.5 * Y)

	end if

500	continue
	KONF_LVL = amax1 (V, 0.)

	return
	end
