*CMZ :          09/08/96  15.34.53  by   Ivan Belyaev
*CMZ :  1.00/01 03/08/96  18.49.59  by   Ivan Belyaev
*CMZ :  1.04/10 23/11/95  13.10.09  by  joerg f. rieling
*CMZ :  1.04/09 09/11/95  15.19.34  by  joerg f. rieling
*CMZ :  1.04/06 26/06/95  16.31.43  by  joerg f. rieling
*CMZ :  1.04/05 01/06/95  09.37.13  by  joerg f. rieling
*CMZ :  1.04/04 25/05/95  13.45.01  by  joerg f. rieling
*CMZ :  1.04/03 22/05/95  15.50.56  by  joerg f. rieling
*-- Author :

c--------------------------------------------------
        subroutine sinit
c	--- converts official geo data into faster
c	--- and simpler format for SiVD
c--------------------------------------------------

	implicit none

c	--- CDEs

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/GEO.fi"
#include "auto/SI.fi"

#include "gean/ZGESL.fi"
#include "susi/zsiconst.fi"
#include "susi/zsigeo.fi"
#include "susi/zsinavi.fi"
#include "susi/zsiseed.fi"

c	--- misc
        INTEGER    n_totpl, n, i, j, k ,LUN,IOS
	LOGICAL    noswap

c	--- help for sorting
	REAL aux
	INTEGER index(N_TOTSIPL)
	INTEGER pplid(N_TOTSIPL)
	REAL    pplz  (N_TOTSIPL),pplxmi(N_TOTSIPL),pplymi(N_TOTSIPL)
	REAL    pplxma(N_TOTSIPL),pplyma(N_TOTSIPL),pplcsa(N_TOTSIPL)
	REAL    pplsna(N_TOTSIPL)
	REAL    pplcsr(N_TOTSIPL),pplsnr(N_TOTSIPL),pplsg(N_TOTSIPL)
	REAL    pplsgd(N_TOTSIPL)
	REAL    pplms (N_TOTSIPL)

        INTEGER ITMP(N_TOTSIPL)
        INTEGER NTMP

        LOGICAL fromCONST
        SAVE    fromCONST

        INTEGER  iAUX, jAUX, iNEXT

        INTEGER  LENOCC,IUCOMP
        EXTERNAL LENOCC,IUCOMP 

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/SI.ff"

#include "susi/zsigeo.ff"

      IF( JSUSI .NE. 0)THEN
C*     SUSi Tables Exist in CONST file
       C78='SUSi==>SINIT: SUSi table exists!'
       CALL MEMESC(384622,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       fromCONST=.TRUE.
      ELSE
C*     SUSi Tables either do not exist in  CONST file or
C*     have not been read yet. Try to initialise SUSi
C*     from data files SUSISEED and SUSINAVI
       IF( BITTEST(INOUTFARM,1) .EQ. 0 )THEN
C*      Such initialisation is not possible on FARM
        C78='SUSi==>SINIT: SUSi initialisation from data files'
        CALL ME78AP
        fromCONST=.FALSE.
        IF(JSNAV.NE.0)CALL MMDROP(JSNAV)
        IF(JSNAX.NE.0)CALL MMDROP(JSNAX)
        IF(JSPAS.NE.0)CALL MMDROP(JSPAS)
        IF(JSSEE.NE.0)CALL MMDROP(JSSEE)
        CALL MMBOOK(JSUSI,1)
C*      Read NAVI File
        LUN=0
        CALL IOFIND('SUSINAVI',LUN)
         IF(LUN.LE.0.OR.LUN.GT.99)THEN
          C78='SUSi==>Sinit ERROR! Problems with NAVI-file'
          CALL ME78AP
          GO TO 998
         ENDIF
        CALL IOOPEN(LUN,'O',0,IOS)
        IF( IOS .NE. 0 )THEN
          C78='SUSi==>Sinit ERROR! Cannot open NAVI-file'
          CALL ME78AP
          GO TO 998
        ENDIF
c       --- read navi table
        DO i=1, N_TOTSIPL
           read (LUN,*,err=998) n_next_plane(i),
     &    (next_plane(i,j),j=1,n_next_plane(i))
         CALL MMBOOK(JSNAV,1)
        ENDDO
C*      Build NAVI relation
        DO i=1,NSNAV()
         IQ(IQSNAV_NPLA(i))=0
         DO j=1,n_next_plane(i)
          CALL MMBOOK(JSNAX,1)
          IQ(IQSNAX_NEXT_L())=NEXT_PLANE(I,n_next_plane(i)-J+1)
          IQ(IQSNAV_NPLA(i)) = ISNAV_NPLA(i)+1
          CALL MMBREL(JSNSN,I,NSNAX())
         ENDDO
        ENDDO
C*      End of NAVI relation
        CALL IOCLOS(LUN)
C*      Read SEED Table
        LUN=0
        CALL IOFIND('SUSISEED',LUN)
         IF(LUN.LE.0.OR.LUN.GT.99)THEN
          C78='SUSi==>Sinit ERROR! Problems with SEED-file'
          CALL ME78AP
          GO TO 998
         ENDIF
        CALL IOOPEN(LUN,'O',0,IOS)
        IF( IOS .NE. 0 )THEN
          C78='SUSi==>Sinit ERROR! Cannot open SEED-file'
          CALL ME78AP
          GO TO 998
        ENDIF
        DO i=1, N_MAXPASS
         read(LUN,*,err=998) n_seeds(i)
         DO j=1, n_seeds(i)
          read(LUN,*,err=998)(seedpl(i,j,k),k=1,4)
         ENDDO
        ENDDO
C**     START of SEED Table
        DO i=1,N_MAXPASS
         CALL MMBOOK(JSPAS,1)
         DO j=1,n_seeds(i)
          CALL MMBOOK(JSSEE,1)
          IQ(IQSSEE_PLN1_L())=seedpl(i,n_seeds(i)-j+1,1)
          IQ(IQSSEE_PLN2_L())=seedpl(i,n_seeds(i)-j+1,2)
          IQ(IQSSEE_PLN3_L())=seedpl(i,n_seeds(i)-j+1,3)
          IQ(IQSSEE_PLN4_L())=seedpl(i,n_seeds(i)-j+1,4)
          CALL MMBREL(JSPSS,NSPAS(),NSSEE())
         ENDDO
        ENDDO
        CALL IOCLOS(LUN)
       ELSE
C*      SUSi Initialisation form File is not possible on FARM!!!!
        C78='SUSi==>SINIT:Initialisation from FILE impossible'
        CALL ME78AP
        CALL ATSTOP('SUSi==> Initialisation failed!')
       ENDIF
      ENDIF


      n_totpl = NGEDE()

C*    Get SiVD planes, check if number OK
      N = 0
      DO i=1, NGEDE()
       IF( IGEDE_CMP(i)  .EQ.  LGESL_SIL
     &                   .AND.
     &     FGEDE_ZMIN(i) .LT. Z_SIMAX ) THEN
        N = N + 1
        IF(n.le.N_TOTSIPL) THEN
         pplid(n) = i
        ELSE
         C78='SUSi==>Sinit ERROR! Too many S-Pl!'
         CALL MEERRO(C78(1:LENOCC(C78)))
         n=N_TOTSIPL
        ENDIF
       ENDIF ! Si-GEDE ?
      ENDDO  ! i
      IF (N.NE.N_TOTSIPL.OR.N.NE.NSNAV()) THEN
       C78='SUSi==>Sinit ERROR not many SiPlanes as Expected'
       CALL CH78BI( N         )
       CALL CH78CI( N_totsipl )
       CALL CH78CI( NSNAV()   )
       CALL ME78AP
       CALL ATSTOP('SUSi==>Fatal Initialisation Error!')
      ENDIF
c     Convert geometry data to internal geometry data
      DO i=1, n
       pplz  (i) = FGEDE_ZFW(1, pplid(i))
       pplxmi(i) = FGEDE_SXMN(pplid(i))
       pplxma(i) = FGEDE_SXMX(pplid(i))
       pplymi(i) = FGEDE_SYMN(pplid(i))
       pplyma(i) = FGEDE_SYMX(pplid(i))
       pplcsa(i) = FGEDE_ROT (pplid(i),1)
       pplsna(i) = FGEDE_ROT (pplid(i),2)
       pplcsr(i) = FGEDE_COS (pplid(i))
       pplsnr(i) = FGEDE_SIN (pplid(i))
       pplsg (i) = FGEDE_ACC (pplid(i))
       pplsgd(i) = FGEDE_DOD (pplid(i))
       pplms (i) = FGEDE_MS  (pplid(i))
       index (i) = i ! pointer field for sorting
      ENDDO ! i
C*    Sort  data (increasing z); exit.
      DO i=1, N_TOTSIPL - 1
       noswap = .true.
       DO j=1, N_TOTSIPL - i
	IF (pplz(index(j)).gt.pplz(index(j+1)))THEN
	 aux        = index(j)
	 index(j)   = index(j+1)
	 index(j+1) = aux
	 noswap = .false.
	ENDIF
       ENDDO  ! j
       IF (noswap) GOTO  10
      ENDDO  ! i
 10   CONTINUE
      DO i=1, N_TOTSIPL
C**    Update SNAV Table
       IF( I.GT.0.AND.I.LE.NSNAV())THEN
        IQ(IQSNAV_GEDE(i))=pplid(index(i))
       ELSE
        C78='SUSi==>SINIT Error: Index'
        CALL CH78BI( i )
        CALL CH78BC( 'NSNAV()=')
        CALL CH78AI( NSNAV() )
        CALL MEERRO(C78(1:LENOCC(C78)))
       ENDIF
      ENDDO
      
      DO i=1,NSNAV()
       IF( ISNAV_GEDE( i ) .LE. 0  .OR. 
     &     ISNAV_GEDE( i ) .GT.  NGEDE() )THEN 
        C78='SUSi Error! SNAV table is not properly filled!'
        CALL MEERRO(C78(1:LENOCC(C78)))    
       ENDIF  
       IF( IGEDE_CMP( ISNAV_GEDE( i ) ) .NE.
     &     LGESL_SIL )THEN
        C78='SUSi Error! Not Silicon Plate!' 
        CALL MEERRO(C78(1:LENOCC(C78)))
       ENDIF
      ENDDO 

C*    Fill SNAB Table 
      IF( JSNAB .NE. 0 )CALL MMDROP( JSNAB )

      DO i = 1 , NSNAV()
       IQ(IQSNAV_NBAC(i))=0
       NTMP = 0        
       DO J = 1 , NSNAV()
        jAUX = PSNAV_SNAX( j ) 
        DO WHILE( jAUX .NE. 0 )
         iAUX  = MSNAV_SNAX( jAUX ) 
         iNEXT = ISNAX_NEXT( iAUX ) 
         IF( iNEXT .EQ. i )THEN
          IF( IUCOMP(J,ITMP,NTMP).EQ.0)THEN
           NTMP=NTMP+1
           ITMP(NTMP)=J
          ENDIF 
         ENDIF 
         jAUX  = XSNAV_SNAX( jAUX ) 
        ENDDO 
       ENDDO 
       DO J = 1 , NTMP
        CALL MMBOOK(JSNAB,1)
        IQ(IQSNAB_NEXT_L()) = ITMP(J)
        CALL MMBREL(JSBSN,I,NSNAB())
        IQ(IQSNAV_NBAC(i))=ISNAV_NBAC(i)+1
       ENDDO 
      ENDDO         

  
C*    Set the default values for SUSi Parameters
      IF( JSPAR .LE. 0 )THEN
       CALL SUSIDEFV
       IQ(IQSPAR_NMOD_L())=ISPAR_NMOD(NSPAR())+1
      ENDIF 
      IF( JSSTA .EQ. 0 )CALL SUSISTAT
 
      GO TO  999

 998  CONTINUE
      C78='SUSi==>Sinit ERROR! Cannot read  data files!'
      CALL MEERRO(C78(1:LENOCC(C78)))

 999  CONTINUE
      RETURN
      END








