>NAME SUSiKUIP

>Menu      /SUSI
>Guidance
Commands Specific for SUSi

>Command NAVI
>Guidance
Create/Modify the Navigation Arte Tables SNAV and SNAX Tables for SUSi
>Action SKASNAV
>Parameter
NPLANES 'Number of Planes for Current Row in SNAV' I D=0
+
N1  ' 1st Plane Number' I D=0
N2  ' 2nd Plane Number' I D=0
N3  ' 3rd Plane Number' I D=0
N4  ' 4th Plane Number' I D=0
N5  ' 5th Plane Number' I D=0
N6  ' 6th Plane Number' I D=0
N7  ' 7th Plane Number' I D=0
N8  ' 8th Plane Number' I D=0
N9  ' 9th Plane Number' I D=0
N10 '10th Plane Number' I D=0
N11 '11th Plane Number' I D=0
N12 '12th Plane Number' I D=0
N13 '13th Plane Number' I D=0

>Command PASS
>Guidance
Create/Modify the Arte Table SPAS (PASS table for SUSi)
>Action SKASPAS
>Parameter
N      'Number of SEEDing combination in the PASS' I  R=1:100

>Command SUSISEED
>Guidance
Create/Modify the Arte Table SSEE ( SEED table for SUSi)
>Action SKASPAS
>Parameter
PLANE1 'First   SEEDing Plane Number ' I R=1:1000
PLANE2 'Second  SEEDing Plane Number ' I R=1:1000
PLANE3 'Third   SEEDing Plane Number ' I R=1:1000
PLANE4 'Fourth  SEEDing Plane Number ' I R=1:1000

>Command SUSIPARAMETERS 
>Guidance 
Modify the default SUSi parameters.
Be careful to change the default parameters! 
Changing of ALGO and SEED results in reset of SUSi statistics. 
To be extended in future 
identifiers:  'DEF'  - switch to default values 
              'QUA'  - value of minimal accepted quality of the track
              'PER'  - value of correct hit percentage for MC-assignment
              'WMIS' - weight for missing hits in track quality definition
              'WCHI' - weight for chi2 value in track quality definition 
              'MINT' - Minimal tolerance Parameter in 4-plane SEEDing scheme
              'MAXT' - MAximal Tolerance Parameter in 4-plane SEEDing scheme
              'ANTT' - Angulat Tolerance Parameter in 4-plane SEEDing scheme
              'TWI'  - Target Window Parameter in 4-plane SEEDIng scheme 
              'PMI'  - Minimal Allowed Particle Momentum 
              'MHS'  - MIN_HITSL Parameter 
              'PROP' - Flag for Proper Tracks business (0-no proper tracks)
              'ALGO' - refit algorithm (0-no refit)
              'RPNT' - Flag for Reconstructed Points business (0-no points)
              'ANGU' - Flag for 2-plane SEEDing scheme. 0-minimal Z 
              'SEED' - Choice for SEEDing scheme. 2-plane or 4-plane.  
>Action SKAPARA 
>Parameter 
KEY    'Parameter identifier'    C D='DEF'
VALUE  'Value of the parameter' R  

>Command SUSIPRINT 
>Guidance 
Manage the SUSi Statistical PrintOut. 
N = 0 No Statistical Printout 
N > 0 The PRintout will be done for the next N events 
N < 0 The PrintOut will be done every |N| event 
>Action skaprnt 
>Parameter 
VALUE  'PrintOut Flag' I D=0 

>Command SUSISTATISTICS 
>Guidance 
Reset the SUSi Statistics Counters. 
>Action skastat

