*CMZ :          23/02/96  17.32.52  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   23/02/96

      SUBROUTINE DDRTYP (KR, IT)

************************************************************************
*
* Description: get the relation type (one-one ... many-many
*
* Called from: DD
*
* External references: none
*
* Argument in/out description
* KR       in     relation
* IT       out    type: 1 = o-o; 2 = o-m; 4 = m-m
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER KR, IT, K

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IT = 0
      DO 10 K = 1, NDDEF()
        IF (HDDEF_NAM3(K) .NE. HDDEF_NAM3(KR))  GO TO 10
        IF (IDDEF_FLAG(K) .EQ. LDDEF_RE1)  IT = IT + 1
        IF (IDDEF_FLAG(K) .EQ. LDDEF_REM)  IT = IT + 2
        IF (IDDEF_FLAG(K) .EQ. LDDEF_INM)  IT = IT + 2
 10   CONTINUE
      IF (IT .EQ. 3)  IT = 2

 90   END

************************************************************************
* End of DDRTYP
************************************************************************
