*CMZ :  2.01/01 17/05/95  15.54.19  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   04/03/95

      SUBROUTINE IOFIND (CSYM, LUN)

************************************************************************
*
* Description: find logical unit number or get an unused one.
*
* Called from: anywhere
*
* External references: MEERRO, IODECL
*
* Argument in/out description
*   LUN    out    logical unit number
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZIOCOM.fi"

      INTEGER L, LUN
      CHARACTER*(*) CSYM

#include "arte/Arte.ff"

      L = 0
      DO 10 LUN = 1, 99
      IF (IIOFLG(LUN) .GE. 0)  THEN
        IF (CIOSYM(LUN) .EQ. CSYM .AND. CSYM .NE. ' ')  GO TO 90
      ELSE
        L = LUN
      END IF
 10   CONTINUE

      LUN = L
      IF (LUN .NE. 0)  THEN
        CALL IODECL (LUN, CSYM, '(unspecified)')
      ELSE
        CALL MEERRC (25,
     +    'IOFIND: all 99 logical unit numbers used up')
      END IF

 90   END

************************************************************************
* End of IOFIND
************************************************************************
