*CMZ :  2.01/01 18/07/95  14.33.06  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   17/02/95

      SUBROUTINE IOUNIT (CSYM, LUN)

************************************************************************
*
* Description: Get logical unit number LUN from file name CSYM
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   CSYM   in     file name
*   LUN    out    logical unit number
*
************************************************************************

      IMPLICIT NONE

#include "arte/ZIOCOM.fi"

      CHARACTER *(*) CSYM
      INTEGER LUN

      IF (CSYM .EQ. ' ')  GO TO 20
      DO 10 LUN = 1, 99
 10   IF (CIOSYM(LUN) .EQ. CSYM)  GO TO 30
 20   LUN = 0

 30   END

************************************************************************
* End of IOUNIT
************************************************************************
