*CMZ :  2.01/01 06/12/95  16.58.06  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   23/06/95

      SUBROUTINE MMTREL (JL, CN, IDIV, JR1, IP1, JR2, IP2, IFLG)

************************************************************************
*
* Description: declare a relation
*
* Called from:
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER JL, IDIV, JR1, IP1, JR2, IP2, HN, IFLG
      INTEGER IL, IR1, IR2, LOCF
      CHARACTER CN*(*), C4*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      C4 = CN
      CALL CLTOU (C4)
      CALL CHCTOH (C4, HN, 1)

      IF (IDIV .NE. IXEVNT .AND. IDIV .NE. IXCONS)  THEN
         C78 = 'MMTREL: Zebra division not properly given'
         GO TO 80
      END IF

      IL = LOCF(JL)
      IR1 = LOCF(JR1)
      IR2 = LOCF(JR2)

      IF (IL  .LE. LARLN1 .OR. IL  .GT. LARLNL .OR.
     +    IR1 .LE. LARLN1 .OR. IR1 .GT. LARLNL .OR.
     +    IR2 .LE. LARLN1 .OR. IR2 .GT. LARLNL)  THEN
         C78 = 'MMTREL: Zebra link outside link area'
         GO TO 80
      END IF

      IL  = IL  - LARLN1
      IR1 = IR1 - LARLN1
      IR2 = IR2 - LARLN1

      IQ(HQMEMO_NAME(IL)) = HN
      IQ(IQMEMO_DIV(IL)) = IDIV
      IQ(IQMEMO_FMT(1,IL)) = 2
      IQ(IQMEMO_EXT(IL)) = 2000
      IQ(IQMEMO_COL(IL)) = 2
      IQ(IQMEMO_FLAG(IL)) = IFLG
      IF (IFLG .EQ. 4)  IQ(IQMEMO_COL(IL)) = 4
      IQ(IQMEMO_SUP(1,IL)) = IR1
      IQ(IQMEMO_SUP(2,IL)) = IR2
      IQ(IQMEMO_POS(1,IL)) = IP1
      IQ(IQMEMO_POS(2,IL)) = IP2

      GO TO 90

   80 CALL ME78EC (7245133)

   90 END

************************************************************************
* End of MMTREL
************************************************************************
