*CMZ :  2.01/01 14/11/95  20.54.00  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/03/95

      SUBROUTINE MMTSUB (JL, JS, IFL)

************************************************************************
*
* Description: handle row size and format of tables
*
* Called from: ATBANK etc.
*
* External references:
*
* Argument in/out description
* JL       in     link to subordinate table
* JS       in     link to superior table
* IFL      in     =0: subordinate; = 1: parallel table
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER JL, JS, IX, IS, IFL, LOCF

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      IX = LOCF(JL)
      IS = LOCF(JS)

      IF (IX .LE. LARLN1 .OR. IX .GT. LARLNL .OR.
     +    IS .LE. LARLN1 .OR. IS .GT. LARLNL)  THEN
        CALL MEERRC (8126487, 'MMTSUB: Zebra link outside link area')
        GO TO 90
      END IF

      IX = IX - LARLN1
      IS = IS - LARLN1

      IQ(IQMEMO_SUP(1,IX)) = IS
      IQ(IQMEMO_SUP(2,IX)) = 0
      IF (IFL .NE. 0)  IQ(IQMEMO_FLAG(IX)) = -1

 90   END

************************************************************************
* End of MMTSUB
************************************************************************
