//-- Author :    Hartwig Albrecht  Aug 9, 96
 
// *****************************************************************************
//
// Source:    utenvi.C
// Get environment variables and fill it into ArteFlag
//
// *****************************************************************************
 
// includes
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "arte/ArteFlag.h"
 
// prototypes
extern "C"
{
  void utenvi_();
// fill Fortran character strings with blank spaces:
  void utfbla (int, char*);
}
 
void utenvi_() {
 
// locals

  char *ptr;
  FILE *pipe;

  ptr = &arteflag_.hostname[0];
  pipe = popen ("echo $HOST", "r");
  fscanf (pipe, "%78s", ptr);
  utfbla (78, ptr);
  pclose (pipe);

  ptr = &arteflag_.instname[0];
  pipe = popen ("echo $SITE", "r");
  fscanf (pipe, "%78s", ptr);
  utfbla (78, ptr);
  pclose (pipe);

  ptr = &arteflag_.bintype[0];
  pipe = popen ("echo $BINTYPE", "r");
  fscanf (pipe, "%78s", ptr);
  utfbla (78, ptr);
  pclose (pipe);

  ptr = &arteflag_.srcname[0];
  pipe = popen ("pwd", "r");
  fscanf (pipe, "%78s", ptr);
  utfbla (78, ptr);
  pclose (pipe);

  ptr = &arteflag_.hbdir[0];
  pipe = popen ("echo $HB", "r");
  fscanf (pipe, "%78s", ptr);
  utfbla (78, ptr);
  pclose (pipe);

  arteflag_.processid = getpid ();
}
