
      SUBROUTINE UTFARG( IARG, CARG )

************************************************************************
*
* description: fill character variables with arguments of program
*
* called from: C function utcarg
*
* External references:
*
* argument in/out description
*          in     IARG argument number
*          in     CARG character string
*
* created: 27 Oct 95
* updated: 17 Aug 98
*
* author:  Andreas Gellrich
*          HERA-B Collaboration
*          DESY Zeuthen
*          Platanenallee 6
*          D-15738 Zeuthen
*          Germany
*          email: Andreas.Gellrich@desy.de
*
************************************************************************
      
      IMPLICIT NONE
      
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
      
*     local variables
      INTEGER      J, IARG, CARG(*), JBATCH(0:1), KBATCH(0:1)
      DATA JBATCH /4HINTE, 4HBATC/
      DATA KBATCH /4Hinte, 4Hbatc/
      
#include "arte/Arte.ff"
      
*     fill character variables for steering in common (used in UTINIT)
      IF( IARG .EQ. 1 )  THEN
         PROGNAME = ' '
         CALL CHHTOC (CARG, PROGNAME)
      END IF
      IF( IARG .EQ. 2 ) THEN
         DO J = -1, 1
            IF (CARG(1) .EQ. JBATCH(J)) IBATCH = J
            IF (CARG(1) .EQ. KBATCH(J)) IBATCH = J
         END DO
      END IF
      
      END
      
************************************************************************
*     End of UTFARG
************************************************************************

