#ifndef _DBARTEBRIDGE_H_
#   define _DBARTEBRIDGE_H_

#   define NIOMAX 1000

extern struct {

  int iiosta[NIOMAX],iioflg[NIOMAX],
      niolen[NIOMAX],iiofmt[NIOMAX],
      iionxt[NIOMAX],niorec[NIOMAX],
      iiocur[99];

  unsigned int iiobit[99];

  int jiobnk[99],nioskp[99],
      iioskp[99],niousd;

  float fiomix[5],fioutm[NIOMAX];

} ziocom_;

int DbOpen(char *, char *);
int DbClose(char *);
int dbopen_(char *, char *, int, int );
int dbclos_(char *, int );
int dbwrit_(char*, int*, int*, int*, int);
int dbread_(char*, int*, int*, int*, int);
int dbwtab_(char*, int*, int*, int*, int);
int dbrtab_(char*, int*, int*, int*, int);
int DbWriteHeader(char*, int*, int, int);
int DbReadHeader(char*, int*, int, int);
int DbWriteTable(char*, int*, int, int);
int DbReadTable(char*, int*, int, int);

#endif




