#ifndef _MTRX_H_
#define _MTRX_H_
typedef struct {
   float MASS;
   float LENG;
   int oBVER;
   int oBTRA;
   int pETRA;
   int pEVER;
   int pMIMP;
   int pMCAL;
   int pRTRA;
   int pRSEG;
   int pRCCL;
   int oMTCP;
} mtrx;
#define  JMTRX (gcbank_.iq+artelink_.jmtrx)
#define  NMTRX() N_U(JMTRX)
#define NCMTRX() N_C(JMTRX)
#define MTRX(i) (*((mtrx*)(JMTRX+2)+(i)-1))
#define MTRX_oBVER(i) MTRX(i).oBVER
#define MTRX_oBTRA(i) MTRX(i).oBTRA
#include "auto/MTMT.h"
#define MTRX_pETRA(i) MTRX(i).pETRA
#define MTRX_mETRA(i) M_R(i,JMTMT)
#define MTRX_xETRA(i) X_R(i,JMTMT)
#include "auto/MTMV.h"
#define MTRX_pEVER(i) MTRX(i).pEVER
#define MTRX_mEVER(i) M_R(i,JMTMV)
#define MTRX_xEVER(i) X_R(i,JMTMV)
#include "auto/MTMI.h"
#define MTRX_pMIMP(i) MTRX(i).pMIMP
#define MTRX_mMIMP(i) M_R(i,JMTMI)
#define MTRX_xMIMP(i) X_R(i,JMTMI)
#include "auto/MTMC.h"
#define MTRX_pMCAL(i) MTRX(i).pMCAL
#define MTRX_mMCAL(i) M_R(i,JMTMC)
#define MTRX_xMCAL(i) X_R(i,JMTMC)
#include "auto/RTMT.h"
#define MTRX_pRTRA(i) MTRX(i).pRTRA
#define MTRX_mRTRA(i) M_1(i,JRTMT)
#define MTRX_xRTRA(i) X_1(i,JRTMT)
#include "auto/RSMT.h"
#define MTRX_pRSEG(i) MTRX(i).pRSEG
#define MTRX_mRSEG(i) M_1(i,JRSMT)
#define MTRX_xRSEG(i) X_1(i,JRSMT)
#include "auto/MTRC.h"
#define MTRX_pRCCL(i) MTRX(i).pRCCL
#define MTRX_mRCCL(i) M_2(i,JMTRC)
#define MTRX_xRCCL(i) X_2(i,JMTRC)
#define MTRX_oMTCP(i) MTRX(i).oMTCP
#endif
