#ifndef _NEDE_H_
#define _NEDE_H_
typedef struct {
   int CMP;
   int LAY;
   int SEC;
   int SHP;
   float XMIN;
   float XMAX;
   float YMIN;
   float YMAX;
   float ZMIN;
   float ZMAX;
   float SXMN;
   float SXMX;
   float SYMN;
   float SYMX;
   float COS;
   float SIN;
   float ROT[9];
   float ACC;
   float EFF;
   float DOD;
   float PIT;
   float MS;
   float XFW[4];
   float ZFW[4];
   int NWI[4];
   int NSL;
   int oNESL;
   int oNMAT;
   int NWL;
   int FWL;
   float XMAD;
   float YMAD;
   float ZMAD;
   float Y1W[4];
   float Y2W[4];
   char GVOL[4];
   char HWC[12];
   float DEDX;
   int GCOP;
} nede;
#define  JNEDE (gcbank_.iq+artelink_.jnede)
#define  NNEDE() N_U(JNEDE)
#define NCNEDE() N_C(JNEDE)
#define NEDE(i) (*((nede*)(JNEDE+2)+(i)-1))
#define NEDE_oNESL(i) NEDE(i).oNESL
#define NEDE_oNMAT(i) NEDE(i).oNMAT
#endif
