#ifndef _PTGE_H_
#define _PTGE_H_
typedef struct {
   int FLAG;
   int ARTE;
   int DB;
   char NAME[4];
   char SUPL[4];
   char MOTH[4];
   char SHAP[4];
   char MATE[12];
   char MAON[4];
   int IROT;
   float ROTM[9];
   float XMIN;
   float XMAX;
   float YMIN;
   float YMAX;
   float ZMIN;
   float ZMAX;
   float DX;
   float DY;
   int NX;
   int NY;
   int DIR;
   int COLO;
   int FILL;
   int SEEN;
   char COMM[128];
   int FSTC;
   int LSTC;
   int pPTCE;
   int pPTAL;
} ptge;
#define  JPTGE (gcbank_.iq+artelink_.jptge)
#define  NPTGE() N_U(JPTGE)
#define NCPTGE() N_C(JPTGE)
#define PTGE(i) (*((ptge*)(JPTGE+2)+(i)-1))
#include "auto/PXGC.h"
#define PTGE_pPTCE(i) PTGE(i).pPTCE
#define PTGE_mPTCE(i) M_R(i,JPXGC)
#define PTGE_xPTCE(i) X_R(i,JPXGC)
#include "auto/PXGA.h"
#define PTGE_pPTAL(i) PTGE(i).pPTAL
#define PTGE_mPTAL(i) M_R(i,JPXGA)
#define PTGE_xPTAL(i) X_R(i,JPXGA)
#endif
