#ifndef _RTRA_H_
#define _RTRA_H_
typedef struct {
   float ZF;
   float XF;
   float YF;
   float TXF;
   float TYF;
   float PF;
   float CVF[15];
   int HSI;
   int HIN;
   int HOU;
   int HRI;
   int HCA;
   int HTR;
   int HMU;
   int FIT;
   float CHI;
   float LRE;
   float LRMU;
   float LRPI;
   float LRK;
   float LRP;
   int FLR;
   int oTOPP;
   float LTE;
   float LTH;
   int FLT;
   float LEE;
   float LEMI;
   float LEH;
   int FLE;
   float LMMU;
   float LMH;
   int FLM;
} rtra;
#define  JRTRA (gcbank_.iq+artelink_.jrtra)
#define  NRTRA() N_U(JRTRA)
#define NCRTRA() N_C(JRTRA)
#define RTRA(i) (*((rtra*)(JRTRA+2)+(i)-1))
#define RTRA_oTOPP(i) RTRA(i).oTOPP
#endif
