#ifndef _RTRA_HH_
#define _RTRA_HH_
struct RTRA {
   float zf;
   float xf;
   float yf;
   float txf;
   float tyf;
   float pf;
   float cvf[15];
   int hsi;
   int hin;
   int hou;
   int hri;
   int hca;
   int htr;
   int hmu;
   int fit;
   float chi;
   float lre;
   float lrmu;
   float lrpi;
   float lrk;
   float lrp;
   int flr;
   ArtePointer<TOPX> topp;
   float lte;
   float lth;
   int flt;
   float lee;
   float lemi;
   float leh;
   int fle;
   float lmmu;
   float lmh;
   int flm;
};
#include "auto/TOPX.hh"
#include "auto/RTTO.hh"
#include "auto/RTRA.icc"
#endif
