
      SUBROUTINE CAFMBD( FNUM, ILC)

************************************************************************
*-- Author :    Olga Igonkina   10/09/96
*
* Description: subsidiary subroutine for integration (ECAL miniMC package)
*
* Called from: CAFMLO
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

      INTEGER FNUM, XNUM, ILC
      INTEGER BSIG
      DIMENSION BSIG(2)
      REAL SHELP, BD1, BD2

#include "arte/Arte.fi"
#include "gean/cafmcl.fi"
#include "gean/cafmco.fi"
#include "gean/cafmcc.fi"
#include "arte/Arte.ff"

        ILC = 0

        IF( ABS(LL(FNUM,1)-LL(FNUM+1,1)).GE.0.1E-6 )THEN
          XNUM = 1
        ELSE
          XNUM = 2
        ENDIF

        BSIG(1) = 1.
        BSIG(2) = 1.
        IF( LL(FNUM,XNUM).LT.LL(FNUM+1,XNUM) )THEN
          BSIG(XNUM) = -1.
        ENDIF

        S(1,XNUM) = S(1,XNUM) * BSIG(XNUM)
        S(2,XNUM) = S(2,XNUM) * BSIG(XNUM)
        BD1 = LL(FNUM,XNUM) * BSIG(XNUM)
        BD2 = LL(FNUM+1,XNUM) * BSIG(XNUM)

         IF( S(2,XNUM).GT.S(1,XNUM) )THEN
           SHELP = S(2,1)
           S(2,1) = S(1,1)
           S(1,1) = SHELP
           SHELP = S(2,2)
           S(2,2) = S(1,2)
           S(1,2) = SHELP
         ENDIF

         IF( S(2,XNUM).GE.BD1) GOTO 999
         IF( S(1,XNUM).LT.BD2 ) GOTO 999
         IF( S(1,XNUM).GE.BD1.AND.S(2,XNUM).GE.BD2) THEN
            INUM = INUM + 1
            LC(INUM,1) = LL(FNUM,1)
            LC(INUM,2) = LL(FNUM,2)
            INUM = INUM + 1
            LC(INUM,1) = S(2,1) * BSIG(1)
            LC(INUM,2) = S(2,2) * BSIG(2)
            ILC = 1
            GOTO 999
         ENDIF
         IF( S(1,XNUM).GE.BD1.AND.S(2,XNUM).LT.BD2 )THEN
            INUM = INUM + 1
            LC(INUM,1) = LL(FNUM,1)
            LC(INUM,2) = LL(FNUM,2)
            INUM = INUM + 1
            LC(INUM,1) = LL(FNUM+1,1)
            LC(INUM,2) = LL(FNUM+1,2)
            GOTO 999
         ENDIF
         IF( S(1,XNUM).LT.BD1.AND.S(2,XNUM).GE.BD2 )THEN
            INUM = INUM + 1
            LC(INUM,1) = S(1,1) * BSIG(1)
            LC(INUM,2) = S(1,2) * BSIG(2)
            INUM = INUM + 1
            LC(INUM,1) = S(2,1) * BSIG(1)
            LC(INUM,2) = S(2,2) * BSIG(2)
            ILC = 1
            GOTO 999
         ENDIF
         IF( S(2,XNUM).LT.BD2.AND.S(1,XNUM).GE.BD2 )THEN
            INUM = INUM + 1
            LC(INUM,1) = S(1,1) * BSIG(1)
            LC(INUM,2) = S(1,2) * BSIG(2)
            INUM = INUM + 1
            LC(INUM,1) = LL(FNUM+1,1)
            LC(INUM,2) = LL(FNUM+1,2)
            GOTO 999
         ENDIF

 999   RETURN
      END

************************************************************************
* End of CAFMBD
************************************************************************
