************************************************************************
*
* CALMED
* written by S.Shuvalov/S. Nowak 07/09/94 18.04.48
* 
* This routines defines material constants and media for calorimeter
*
************************************************************************
c
      SUBROUTINE CALMED
C----------------------

      IMPLICIT NONE

      INTEGER IMED,MEDNUM

C*    Define BIRK coefficients for scintillator and homogenious medium

C     polysteren
      IMED = MEDNUM(3,'POLYSTYREN')
      CALL GSTPAR(IMED,'BIRK1',1)
      CALL GSTPAR(IMED,'BIRK2',0.013)
      CALL GSTPAR(IMED,'BIRK3',0.0000096)

C           Inner calorimeter
      IMED = MEDNUM(3,'ECAL_W:Sc')
      CALL GSTPAR(IMED,'BIRK1',1)
      CALL GSTPAR(IMED,'BIRK2',0.013)
      CALL GSTPAR(IMED,'BIRK3',0.0000096)

C          Middle and outer calorimeter
      IMED = MEDNUM(3,'ECAL_Pb:Sc')
      CALL GSTPAR(IMED,'BIRK1',1)
      CALL GSTPAR(IMED,'BIRK2',0.013)
      CALL GSTPAR(IMED,'BIRK3',0.0000096)

      RETURN
      END




