
      SUBROUTINE CAUGEO

************************************************************************
*
* CAUGEO
* written by Sergey Shuvalov 09/94
*
* This routines defines nonstandard .ie user calorimeter geometry 
* the superlayer itself must be defined
* The following indices in ZACAL(start value) and DLCAL(length) are used:
*     1     entire calorimeter
*     2     outer  calorimeter
*     3     medium calorimeter
*     4     inner  calorimeter
*     5     first  alu chip in outer  calorimeter
*     6     second alu chip in outer  calorimeter
*     7     first  alu chip in medium calorimeter
*     8     second alu chip in medium calorimeter
*     9     first  alu chip in inner  calorimeter
*    10     second alu chip in inner  calorimeter
*
* ZACAL(1) is with respect to target, all others with respect to ZACAL(1)
*
************************************************************************

      IMPLICIT NONE

      CHARACTER*4 CSL 

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGCALO.fi"
#include "gean/ZGDETV.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
   
      CALL UHTOC(HGESL_NAME(CALOSL),4,CSL,4)
      CALL CGGESL(CSL,'MOTH',0)
      CALL GSATT(CSL,'COLO',-4)
      CALL GSATT(CSL,'SEEN',0)

  999 RETURN
c
      END


