
      SUBROUTINE CRPOS(NAME,MOTH,ILAY,ISEC,XP,YP,ZP,IROT,MAON,PAR)

************************************************************************
*
* CRPOS
* written by Siegmund Nowak
*
* This routine posit a copy of a volume in GEANT and ARTE banks 
*
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* var1        in           this variable will only be read
*
************************************************************************
      IMPLICIT NONE
      INTEGER ILAY,ISEC,IROT,IUCOMP,IVOS,JVOS,ISHAP,NUMED,JMED,ISV
      INTEGER NPAR(30)
      REAL XP,YP,ZP,PAR(*)
      CHARACTER*4 NAME,MOTH,MAON

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcvolu.fi"
#include "auto/GEO.fi"
      DATA NPAR/3,4,5,11,3,  5,5,7,6,6,  10,9,3,4,0,  0,0,0,0,0,
     +          0,0,0,0,0,   0,0,12,0,0                         /
#include "arte/Arte.ff"
#include "auto/GEO.ff"

C     get detector parameters SHAPE,NPAR and sensitive flag

      IVOS = IUCOMP (NAME, IQ(JVOLUM+1), IQ(JVOLUM-1))
      JVOS = LQ(JVOLUM-IVOS)
      IF(JVOS.EQ.0) CALL MEERRO('CRPOS: NONVALID VOLUME')
      ISHAP = Q(JVOS+2)
      NUMED = Q(JVOS+4)
      JMED = LQ(JTMED-NUMED) 
      IF(JMED.EQ.0) CALL MEERRO('CRPOS >> NONVALID MEDIUM')
      ISV = Q(JMED+7)
      IF(ISV.NE.0) THEN
         CALL GSPOSP(NAME,NGEDE()+1,MOTH,XP,YP,ZP,
     +                                  IROT,MAON,PAR,NPAR(ISHAP))
         CALL CRGEDE(NAME,ILAY,ISEC)
      ELSE 
         CALL GSPOSP(NAME,NGWAL()+1,MOTH,XP,YP,ZP,
     +                                  IROT,MAON,PAR,NPAR(ISHAP))
         CALL CRGWAL(NAME,NGWAL()+1)
      ENDIF
      RETURN
      END




