/************************************************************************
*
* FLDGEO
* written by Siegmund Nowak
*
* This routines fills the Artebank FIELD
*
*       called from G..MAIN
*
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/Arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/zgeom.h"
#include "gean/ZGESL.h"
#include "gean/ZGDETV.h"
#include "auto/GEO.hh"

  extern "C" {

  void fldgeo_() {
    struct FELD fld;  

    ArtePointer<GESL> geslfeld(zgmoth_.FELDSL);
    fld.x = geslfeld->x1;
    fld.y = geslfeld->y1;
    fld.z = geslfeld->z1; 
    fld.r = geslfeld->x2;
    fld.h = geslfeld->y2;
    int beg = 4*(LGESL_FLD-1) + 1; 
    char *fmp =zgdetv_.DETV + beg -1;  
    if(!strncmp(fmp,"FLDS",4)) geslfeld->mfl =0;
    else   geslfeld->mfl =1; 
    ArtePointer<FELD>::append(fld); 
  }  }
  
/* fldgeo_ */

