
      SUBROUTINE GEOPEN (CFILE)

************************************************************************
* written by Siegmund Nowak (from H.Albrechts ddopen.F)
* Description: open file for geometry input
*
* Called from: dat routines
*
* Argument in/out description
*   CFILE  in     file name
*   CEXT   in     extension
*
************************************************************************

      IMPLICIT NONE

      INTEGER IOS, LENOCC,IFIRST
      CHARACTER CFILE*(*), CNAME*256, SUBDIR*128, SR*128, VERS*20 
      LOGICAL EXS
      SAVE IFIRST
#include "arte/Arte.fi"
      DATA IFIRST /0/
#include "arte/Arte.ff"

      IF(IFIRST.EQ.0) THEN
         CALL GETENVF('HB',SR)
         CALL GETENVF('HBVERS',VERS) 
         SUBDIR = SR(1:LENOCC(SR))//'/'//VERS(1:LENOCC(VERS))
         IFIRST = 0
      ENDIF
      CALL IOCLOS (LREAD)
      CNAME = CFILE(1:LENOCC(CFILE))
      INQUIRE(FILE=CNAME(1:LENOCC(CNAME)),EXIST=exs,IOSTAT=IOS)
      IF(EXS) THEN
         CALL MEWARN ('file ' //CNAME(1:LENOCC(CNAME))// 
     +                ' is taken from your home directory')
         GO TO 1
      ENDIF

      CNAME = SUBDIR(1:LENOCC(SUBDIR)) // '/geo/' //
     +                                   CFILE(1:LENOCC(CFILE))
      INQUIRE(FILE=CNAME(1:LENOCC(CNAME)),EXIST=exs,IOSTAT=IOS)
      IF(.NOT.EXS) THEN
         CALL MEWARN( 'no file '//CNAME(1:LENOCC(CNAME))//' is found')
         GO TO 999
      ENDIF
 1    CALL IOCONC (LREAD, CNAME(1:LENOCC(CNAME)), ' ', 0)
      CALL IOOPEN (LREAD, 'FO', 0, IOS)

 999  END

************************************************************************
* End of GEOPEN
************************************************************************
