#ifndef _ZGROT_HH_
#define _ZGROT_HH_

  typedef struct {
  int rotnum;
  float theta1, phi1, theta2, phi2, theta3, phi3;
  int irotm;
  float grot[9], arot[9];
  } hgrot;

class zgrot{
public:

  friend class zgdet;
  friend class zgpos;  
  friend class zgvol;
  friend class zguser;
 
  zgrot::zgrot() {}
  zgrot::~zgrot() {} 
  
  static void zgrot::ini(int n);
  static void zgrot::fin();
  static void zgrot::increase();
  static void zgrot::Set_ind_pt(int n);
  hgrot      *zgrot::get_ptrot(int n); 

  int         zgrot::Readrot(char*, int&);
  int         zgrot::Create_Grot(int &); 

private:
  static  hgrot        *ptrot[33];
  static  int           nrrot[33];
  static  int           maxrot[33];  
  static  int           ind_pt;
};

#endif



