************************************************************************
*
* ITLMED
* written by Siegmund Nowak 09/94
* updated by Thorsten Oest 02/97 for fibres
* This routines DEFINES MATERIAL CONSTANTS AND MEDIA FOR MSGC
*
*     +----------------------------+
*     |                            |   GLAS thickness DGL1MT
*     +----------------------------+
*     +----------------------------+   Gold           DAUXMT
*     |                            |
*     |                            |
*     |                            |   GAS           DGASMT
*     |                            |
*     |                            |
*     |                            |
*     |                            |
*     +----------------------------+
*     |                            |   GLAS          DGL2MT
*     |                            |
*     +----------------------------+
*
************************************************************************

      SUBROUTINE ITLMED
C-----------------------

      IMPLICIT NONE

#include "gean/ZGITR.fi"

      REAL VOL_FIB(2)
      CHARACTER*12 NAM_FIB(2)

C     SIFI-Mixture
      NAM_FIB(1) = 'CARBONFIBRE'
      NAM_FIB(2) = 'POLYSTYREN'

      VOL_FIB(1) = DGL1MT+DGL2MT
      VOL_FIB(2) = DGASMT
      CALL CRMIXT('FIBER',12,2,NAM_FIB,VOL_FIB)

      RETURN
      END


