/************************************************************************
*
* ITR_ARTE
* written by Siegmund Nowak
*
* This routines allows changes in the automatically produced GEDE/GWAL
* banks for the ITR 
*
*       called from G..MAIN
*
* The transferred parameters are
* void ric_arte_(int ngede,int ngwal,char lvols[],int lcopy[],int nlev)
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/Arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "auto/GEO.hh"
#include "gean/ZGESL.h"
#include "gean/zgeom.h"

extern "C" {void itr_arte_(int,int,char*,int*,int);}

void itr_arte_(int ngede,int,char *,int *,int) {

    if(ngede !=0) {  
      ArtePointer<GEDE> gede(ngede);
      gede->zfw[1] = gede->zmax ;} 
}

/* itr_arte_ */
