
      SUBROUTINE MEDCON

************************************************************************
*-- Author :    Siegmund Nowak 8/96
*
* This routines stores de/dx into Arte GMAT tables
*
* called from HGINIT
*
************************************************************************

      IMPLICIT NONE

      INTEGER I,LENOCC,L1,L2,JMA,JMA1
      REAL DEDX
      CHARACTER CNAME*12, GNAME*20, CNAM1*12, CNAM2*12
#include "gean/gclink.fi"
#include "gean/gcphys.fi"
#include "arte/Arte.fi"
#include "auto/GMAT.fi"

#include "arte/Arte.ff"
#include "auto/GMAT.ff"
      
      DO 10 I=1,NGMAT()
      DEDX = FGMAT_LOSS(I)
      IF(DEDX.GT.0.) GO TO 10
      JMA = LQ(JMATE-I)
      CALL UHTOC(IQ(JMA+1),4,GNAME,20)  
      IF(JMA.LE.0) GO TO 10
      JMA1 = LQ(JMA-3)
      CALL UHTOC (IQ(HQGMAT_NAME(1,I)),4,CNAME,12)
      L1 = LENOCC(CNAME)
      CALL CLTOU(CNAME)
      CALL UHTOC(IQ(JMA+1),4,GNAME,20)  
      CALL CLTOU(GNAME)      
      L2 = LENOCC(GNAME)
      IF(((L2-L1).EQ.1 .AND. GNAME(L2:L2).EQ.'$' .AND.
     +                         CNAME(1:L1).EQ.GNAME(1:(L2-1))) .OR.
     +   (L1.EQ.L2. and.CNAME(1:L1).EQ.GNAME(1:(L2))) ) THEN
      
         JMA1 = LQ(JMA-3)
         DEDX = Q(JMA1+IQ(JMA1-1))
         IF(ILOSS.NE.2.and.DEDX.GT.0.)DEDX=DEDX*(1.88+.0289*ALOG(DEDX)) 
         Q( QGMAT_LOSS(I)) = DEDX       
      ELSE
      CALL MEERRO('MEDCON: '//CNAME//' '//GNAME) 
      ENDIF

 10   CONTINUE

      RETURN
      END




