/************************************************************************
*
* MEDMAIN
* written by Siegmund Nowak
*
* This routines defines geometry of the Inner Tracker
*
*       called from G..MAIN
*
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/Arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/zgeom.h"
#include "gean/zgvers.hh"
#include "gean/ZGESL.h"
#include "auto/GEO.hh"

extern "C" {  void medmain_(); }

int   read_dat(FILE *,int &);
FILE  *utfilp(char*,char*);

void medmain_() {
    static char filnam[16];  static FILE *MED_inp;  
    zgmed ZGMED;

//     select file name and  open the file
       strcpy(filnam,"gmat.dat");         
       MED_inp = utfilp(filnam,"");
    
//  now the card handling begins

    for (;;)   {
//  read in one media, rotation or volume block
      int datagroup=0; int nr=0;
     datagroup = read_dat(MED_inp,nr); 

//   no action 
     if (datagroup == 0) continue;                          

//   media
     if (datagroup == 1 || datagroup == -99) ZGMED.Create_Gmed(); 

     if (datagroup == -99 )  {                              //end of file
       arteMsg << " CLOSE FILE " << filnam;    arteMsg.warn();   break;  }   
    }}
  
/* medmain_ */




