
      SUBROUTINE MEDNUMC(I,CINP,L,MEDNUM)

************************************************************************
* Author :    Siegmund Nowak   05/08/96
*
* Description: returns the GEANT medium number for a material CINP 
*              (character variable with lengs L) with medflag I
*              version of function mednum foreseen for calls from c++
*
* Called from: everywhere
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/GMAT.fi"
#include "auto/TMP0.fi"
      INTEGER MEDNUM,I,J,L
      CHARACTER*12 CINP,CNAM,CTAB
#include "arte/Arte.ff"
#include "auto/GMAT.ff"
#include "auto/TMP0.ff"

C       convert lower case into upper case and remove blanks
      CNAM(1:L) = CINP
      IF(L.LT.12) CNAM(L+1:12) = ' '
      CALL CLTOU (CNAM)
C       go through material table GMAT

      MEDNUM = 0
      DO J = 1, NGMAT()
       CALL UHTOC (IQ(HQGMAT_NAME(1,J)),4,CTAB,12)
       CALL CLTOU (CTAB)
       IF(CTAB .EQ. CNAM)  THEN
          MEDNUM = IQ(IQTMP0_TEMP(J)+I-1)
          GO TO 10
       ENDIF
      ENDDO

 10   IF(MEDNUM.EQ.0) THEN
        C78 = 'medium'
        CALL CH78BC(CINP)
        CALL CH78BC('does not exist with sens/magnfld flag')
        CALL CH78BI(I)
        CALL ME78ER
      ENDIF
      RETURN
      END

************************************************************************
* End of MEDNAM
************************************************************************




