
      SUBROUTINE PICD96

************************************************************************
* written by Siegmund Nowak
*
* This routines draws a perspective view of the whole detector
*
*       called from PIMAIN
*
************************************************************************

      IMPLICIT NONE
      INTEGER K
      CHARACTER*4 PERS,CNAME

#include "arte/Arte.fi"
#include "gean/gcflag.fi"
#include "gean/MVOLUM.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      CALL KUGETC(PERS,K)
      CALL GSATT('MOTH','LWID',-7)
      CALL GSATT('BPI1','LWID',1)
      CALL GSATT('BPI1','FILL',0)
      CALL GSATT('BPI2','LWID',1)
      CALL GSATT('BPI2','FILL',0)

      DO  K=1,NGESL()
      IF(IGESL_CMP(K).EQ.LGESL_SIL .OR. IGESL_CMP(K).EQ.LGESL_WCH .OR. 
     +   IGESL_CMP(K).EQ.LGESL_MSG .OR. IGESL_CMP(K).EQ.LGESL_PTC .OR.
     +   IGESL_CMP(K).EQ.LGESL_MUO .OR. IGESL_CMP(K).EQ.LGESL_MUX)THEN  
         CALL UHTOC(HGESL_NAME(K),4,CNAME,4)   
         CALL GSATT(CNAME,'SEEN',-2)
         CALL GSATT(CNAME,'FILL',1) 
      ENDIF
      ENDDO

      CALL GDOPT('HIDE','ON  ')
      CALL GDOPT('SHAD','ON  ')

      IF(PERS.EQ.'P') THEN
         CALL GDRAW('MOTH',75.,150.,0.,10.,10.,.008,.008)
         CALL GDRAWT(1.8,12.4,'RPOT with Si',.3,0.,2,0)
         CALL GDRAWT(4.5,7.9,'PT01-03',.3,0.,2,0)
         CALL GDRAWT(5.6,13.4,'MAGNET',.3,0.,2,0)
         CALL GDRAWT(7.8,8.5,'PC01',.3,0.,2,0)
         CALL GDRAWT(7.8,7.8,' -03',.3,0.,2,0)
         CALL GDRAWT(10.,11.5,'SZH3',.3,0.,2,0)
         CALL GDRAWT(10.4,8.2,'TRD',.3,0.,2,0)
         CALL GDRAWT(11.7,7.8,'CALO',.3,0.,2,0)
         CALL GDRAWT(13.5,4.5,'MUON System',.3,0.,2,0)
      ELSE IF(PERS.EQ.'C'.OR.PERS.EQ.'CX') THEN
         CALL GDRAW('MOTH',90.,180.,0.,10.,10.,.008,.016)
      ELSE IF(PERS.EQ.'CY') THEN
         CALL GDRAW('MOTH',90.,90.,0.,10.,10.,.008,.016)
      ENDIF
      CALL GDHEAD(1001,'HERA-B',.6)
      CALL GDSCAL(10.,2.)

      RETURN
      END

