
      SUBROUTINE PICS96
C----------------------

C   To draw a view of one SI superlayer or its components

      IMPLICIT NONE

      CHARACTER*4 MTDA(4),NAME(4),PERS,NAM,CSL
      INTEGER ICOL(8),IFPL,J,K,NUME(4),LAY,SEC,ISEC
      REAL X, Y
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      DATA ICOL /4,4,2,2,4,4,2,2/
#include "arte/Arte.ff"
#include "auto/GEO.ff"
C
      CALL KUGETC(PERS,J)
      CALL KUGETC(NAM,J)

      DO J=1,NGESL()
      IF(IGESL_CMP(J).EQ.LGESL_SIL) THEN
         CALL UHTOC(HGESL_NAME(J),4,CSL,4)
         IF(CSL.EQ.NAM) GO TO 1 
      ENDIF
      ENDDO
      CALL MEWARN('Superlayer '//NAM//' not found as silicon detector')
      GO TO 999


 1    NAME(1) = NAM
      NUME(1) = J

      IF(IGESL_MFL(J).NE.0) THEN
         MTDA(1) = 'SILM'
         MTDA(2) = 'SICM'
         MTDA(3) = 'SIAM'
         MTDA(4) = 'SIHM'
      ELSE
         MTDA(1) = 'SILZ'
         MTDA(2) = 'SICA'
         MTDA(3) = 'SIAD'
         MTDA(4) = 'SIHY'
      ENDIF

      CALL GSATT(CSL,'SEEN',0)
      CALL GSATT('BAGF','SEEN',0)

      CALL GSATT(MTDA(1),'COLO',1)
      CALL GSATT(MTDA(1),'FILL',1)
      CALL GSATT(MTDA(2),'COLO',2)
      CALL GSATT(MTDA(2),'FILL',1)
      CALL GSATT(MTDA(3),'COLO',3)
      CALL GSATT(MTDA(3),'FILL',1)
      CALL GSATT(MTDA(4),'COLO',4)
      CALL GSATT(MTDA(4),'FILL',1)

      CALL GDOPT('HIDE','OFF ')
      CALL GDOPT('SHAD','ON ')

      CALL KUGETI(LAY)
c      LAY = 1
      CALL KUGETI(SEC)

      IFPL =IGESL_FPL(J)-1

      do 20 k=1,IGESL_NPL(J)
      IF(IGEDE_LAY(IFPL+K).NE.LAY) GO TO 20
      ISEC = IGEDE_SEC(IFPL+K)
      IF(SEC.NE.0 .AND. ISEC.NE.SEC) GO TO 20

c     front side
      NAME(2) = MTDA(1)
      NUME(2) = IFPL + K
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,6.,13.,.25,.25)   ! SILZ
      NAME(2) = MTDA(2)
      NUME(2) = IFPL + 2*K -1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,6.,13.,.25,.25)   ! SICA
      NUME(2) = NUME(2) + 1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,6.,13.,.25,.25)   ! SICA
      NAME(2) = MTDA(3)
      NUME(2) = IFPL + 2*K -1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,6.,13.,.25,.25)   ! SIAD
      NAME(2) = MTDA(4)
      NUME(2) = IFPL + 4*K - 3
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,6.,13.,.25,.25)   ! SIHY 1
      NUME(2) = Nume(2) + 1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,6.,13.,.25,.25)   ! SIHY 2

c     back side
      NAME(2) = MTDA(2)
      NUME(2) = IFPL + 2*K -1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,14.,6.,.25,.25)   ! SICA
      NUME(2) = NUME(2) + 1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,14.,6.,.25,.25)   ! SICA
      NAME(2) = MTDA(3)
      NUME(2) = IFPL + 2*K
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,14.,6.,.25,.25)   ! SIAD
      NAME(2) = MTDA(4)
      NUME(2) = IFPL + 4*K - 1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,14.,6.,.25,.25)   ! SIHY 1
      NUME(2) = Nume(2) + 1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,14.,6.,.25,.25)   ! SIHY 2

 20   CONTINUE

      call gdcol(1)
      x = 8.
      y = 16.
      CALL GDRAWT(x,y,'front side',.4,0.,3,-1)
      x = 8.
      y = 2.
      CALL GDRAWT(x,y,'back side',.4,0.,3,-1)

      CALL GDSCAL(4.,4.)
      CALL GDHEAD(1001,'HERA-B  SI-Superlayer',.6)

 999  RETURN
      END
