#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "arte/Arte.hh"
#include "arte/ArteMessage.hh"
#include "auto/GEHD.hh"
#include "gean/zgvers.hh"

geovers *zgvers::ptvers; 
int zgvers::maxvers ;

void zgvers::ini(int n){ 
        ptvers = new geovers[n];
        if(ptvers==NULL) {
           arteMsg << "no geovers[32] allocated";
           arteMsg.error();      }
        maxvers = n;}

void zgvers::fin() {delete [] ptvers;}   

float  zgvers::Read_geovers(char *card) {
        extern itemlength(char*,int);
        int type;  float vn;  char taga[32];
        int nitem=sscanf(card,"%s %d %f ",taga,&type,&vn);
        if (nitem!=3)  {
           arteMsg <<"check data on version cards in geovers";
           arteMsg.error();}
        geovers *vers = ptvers + type -1 ;
        vers->vers_nr = vn;
        card+=itemlength(card,nitem);
        nitem=sscanf(card,"%s",taga);
        memset(vers->datafile,' ',32);
        if(nitem == 1) {
           int n = strlen(taga);
           if(n <=31) strcpy(vers->datafile,taga);
           ArtePointer<GEHD> gehd(1);
           gehd->gevs[type-1] = vers->vers_nr;}
        return vers->vers_nr;
   }

  float zgvers::Compare_vers_nr(int type) {
        int found = 0;   geovers *vers;
        for (int nr=0;nr<32;nr++) { 
           vers = ptvers + nr;
           if(type == vers->vers_cmp) { found = 1; break;} }
        if(found ==0) { 
            arteMsg <<"vers_nr " << type << " does not exist" ;
            arteMsg.error(); 
	    return 0;}
        else { 
            ArtePointer<GEHD> gehd(1);
            if(gehd->gevs[type-1]==vers->vers_nr)  return vers->vers_nr;
            else return -1.;}}

  char* zgvers::Get_vers_datafile(int type) {
        geovers *vers;
        vers = ptvers + type -1;
        ArtePointer<GEHD> gehd(1);
        if(gehd->gevs[type-1]==vers->vers_nr) return vers->datafile;
        else return "not_found";} 
