*CMZ :  2.01/02 26/01/96  15.00.55  by  Hartwig Albrecht
*CMZ :  2.01/01 18/10/95  11.48.39  by  HERA-B
*-- Author :    Hartwig Albrecht   04/10/95

      SUBROUTINE KABDEC

************************************************************************
*
* Description: BEGDECAY command
*
* Called from: KUIP
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/TDEC.fi"
#include "auto/TDEX.fi"
#include "auto/TOPP.fi"
#include "auto/TOPX.fi"

      INTEGER TPNAM1, L
      CHARACTER CN*12

#include "arte/Arte.ff"
#include "auto/TDEC.ff"
#include "auto/TDEX.ff"
#include "auto/TOPP.ff"
#include "auto/TOPX.ff"

      IF (DECAINIT .NE. 0)
     +   CALL MEERRC (963593,
     +   'BEGdecay: previous decay table not terminated by ENDdecay')

      CALL KUGETS (CN, L)
      DECAINIT = TPNAM1 (CN)
      LUNDINIT = - ABS (LUNDINIT)

      IF (DECAINIT .EQ. 0)  THEN
        C78 = 'BEGdecay: unknown particle'
        CALL CH78BC (CN)
        CALL ME78WC (8634634)
        GO TO 90
      END IF

      CALL MMBOOK (JTDEC, 0)
      L = ITOPX_TDEC(DECAINIT)
      IQ(IQTOPX_TDEC(DECAINIT)) = 0
 10   IF (L .EQ. 0 .OR. L .GT. NTDEC())  GO TO 90
      IQ(IQTDEC_MOTH(L)) = 0
      L = ITDEX_NEXT(L)
      GO TO 10

 90   END

************************************************************************
* End of KABDEC
************************************************************************
