*CMZ :  0.01/02 23/08/94  18.07.59  by  Dominik Ressing
*-- Author :    Dominik Ressing   18/08/94
************************************************************************
*
* L1DETIS
* written by Dominik Ressing, 18/08/94 09.59.30
*
* This routines action:
* returns the inter-section of two regions. The intersection region
* has a stereo angle L1GEOINal of zero.
* If the regions do not overlap the fields sx,sy in
* the structure rInter are set to negative.
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* Detector    in          array of structure GeoInf decribing a detector
* Region      in          array of structure GeoInf decribing a region of intrest
* rInter      out         array of structure GeoInf decribing the intersection
*
************************************************************************
c
      SUBROUTINE L1DETIS(Detector,Region,rInter)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
c
      REAL Detector(L1GEOINFlen),Region(L1GEOINFlen),
     &     rInter(L1GEOINFlen)
c
      CALL l1geo2s(Detector,Region,rInter)
c
      RETURN
c
      END
