*CMZ :  1.00/00 23/09/94  00.33.45  by  Fedor Ratnikov
*CMZ :  0.01/02 23/08/94  16.08.46  by  Dominik Ressing
*-- Author :    Dominik Ressing   23/08/94
************************************************************************
*
* L1GEORT
* written by Dominik Ressing, 23/08/94 15.16.48
*
* This routines action:
* u,v are coordinates with respected to x0,y0 and the stereo angle alpha
*
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* x,y        in           point in unrotated system
* x0,y0      in           center of rotation in unrotated system
* u,v        in           point with respect to x0,y0,alpha
*
************************************************************************
c
      SUBROUTINE L1GEORT(x,y,x0,y0,sin_alpha,u,v)
c
      IMPLICIT NONE
c
      REAL x,y,x0,y0,sin_alpha,u,v,xx,yy
c
      xx = x-x0
      yy = y-y0
c
      u = xx - yy*sin_alpha/sqrt(1.-sin_alpha**2)
      v = yy
c
      RETURN
c
      END
