*CMZ :  1.01/03 03/04/96  09.57.02  by   Ivan Belyaev
*-- Author :     Ivan Belyaev   05/11/95

      SUBROUTINE L1HPTIN( iErr )

************************************************************************
*
* Description:
*
* Called from:
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "l1si/rclink.fi"
#include "l1si/yl1hpt.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/rcfdef.fi"
CCCC IS adviced to add this include to cure the bug (for linux-g77)
#include "l1si/l1clink.fi"

      INTEGER     nLayer
      PARAMETER(  nLayer=3 )

      CHARACTER*4 PTDE( nLayer )
      CHARACTER*16 CHDIR

      INTEGER iLayer , iDetectorName( nLayer ),
     &  iDetector( nLayer ) , iErr ,
     &  iDetSpe( L1DETSPElen ) , nSection ,
     &  iSection , jDetGeo , jDetinf , jCellGeo ,
     &  nX , nY , nCell , iX , iY , Info , LUN ,
     &  lRecl , nReC , iCycle , iLay1 , iLay2 ,
     &  iSection1 , iSection2 , iCell1 , iCell2 ,
     &  IOS , ISTAT , I , J , IOSS,L1HPTlun ,
     &  ISTATZ

      REAL xCell1Start , yCell1Start , zCell1Start,
     &     xCell2Start , yCell2Start , zCell2Start,
     &     xCell1Size  , yCell1Size  ,
     &     xCell2Size  , yCell2Size  ,
     &     xCellSize   , yCellSize   ,
     &     xCell1Projection ,
     &     yCell1Projection , zShift ,
     &     zScaleFactor    , dx , dy

      CHARACTER*100 High_Pt_Table_File_Name

      PARAMETER( lrecl=1024 , nRec = 32000 )
      PARAMETER( zShift=2.0 )
      PARAMETER( L1HPTlun=75)
      PARAMETER( High_Pt_Table_File_Name=
     & 'High-Pt_PreTrigger_Table' )

      INTEGER iQUEST
      COMMON /QUEST/ iQUEST(100)
      LOGICAL  BAVALID ,IEXIST
      INTEGER  L1DETSL  , JBYT
      EXTERNAL L1DETSL , JBYT , BAVALID

c***
      integer iccc, IOD

#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
#include "l1si/yl1hpt.ff"




C*    Drop all old High-Pt Trigger structures
ctmp      IF( JL1CE       .GT. 0 )
ctmp     &    CALL MMDROP(JL1CE)
ctmp      IF( JL1SE    .GT. 0 )
ctmp     &    CALL MMDROP(JL1SE)
ctmp      IF( JLXCC .GT. 0 )
ctmp     &    CALL MMDROP(JLXCC)

       CALL MZLINK( IXCONS , '/L1PTLI/' ,
     &  JPT_CELLS , JPT_CONNECTIONS     ,
     &  JPT_CELLS                       )


      IF(BAVALID(JL1CE,0))CALL MZDROP(IXCONS,JL1CE,'L')
      IF(BAVALID(JL1SE,0))CALL MZDROP(IXCONS,JL1SE,'L')
      IF(BAVALID(JLXCC,0))CALL MZDROP(IXCONS,JLXCC,'L')
      IF(BAVALID(JUSER,0))CALL MZDROP(IXCONS,JUSER,'L')

      CALL UTFTAB('L1SE','1H7I7F',IOD)
      CALL UTBTAB(IXCONS,JL1SE,JL1SE,1,'L1SE',0,0,15,IOD)
      CALL UTFTAB('L1CE','3I',IOD)
      CALL UTBTAB(IXCONS,JL1CE,JL1CE,1,'L1CE',0,0,3,IOD)

C*
      PTDE( 1 ) = 'PTL1'
      PTDE( 2 ) = 'PTL2'
      PTDE( 3 ) = 'PTL3'

C*    Fill SECTIONS and CELLS data tables

      DO iLayer = 1 , nLayer
       CALL UCTOH( PTDE( iLayer ) ,
     &             iDetectorName( iLayer ) , 4 , 4 )
       iDetector( iLayer )  = L1DETSL( iDetectorName( iLayer ) )
       IF ( iDetector( iLayer )  .LT. 1 ) THEN
ctmp        C78='L1HPTIN::==> the unknown Detector Layer'
ctmp        CALL CH78BI (iLayer)
ctmp        CALL CH78CC (PTDE(iLayer))
ctmp        CALL CH78CI (iDetector(iLayer))
ctmp        CALL ME78AP
        WRITE(*,*)'L1HPTIN::==> the unknown Detector Layer'
     &  ,iLayer,PTDE(iLayer),iDetector(iLayer)
        ierr = 1
        RETURN
       ENDIF
c*     Extract global information
       iDetSpe( L1DETSPEdet     ) = iDetector ( iLayer )
       iDetSpe( L1DETSPElayer   ) = 1
       iDetSpe( L1DETSPEsection ) = 1
       CALL l1detif( iDetSpe , jDetGeo , jDetInf , jCellGeo )
       nSection = IQ( jDetInf + L1DETINFnsec  )
c*     extract information about each subdetector
       DO iSection = 1 , nSection

ctmp        CALL MMBOOK( JL1SE,1)
        IF( N_F(JL1SE) .LT. 1 ) THEN
         CALL UTETAB(IXCONS,JL1SE,200)
        ENDIF
        IQ( JL1SE + 2     ) = IQ(JL1SE+2) + 1

        iDetSpe( L1DETSPEdet     ) = iDetector ( iLayer )
        iDetSpe( L1DETSPElayer   ) = 1
        iDetSpe( L1DETSPEsection ) = iSection
        CALL l1detif( iDetSpe , jDetGeo , jDetInf , jCellGeo )
        nX  = IQ( jDetInf + L1DETINFnRow )
        nY  = IQ( jDetInf + L1DETINFnCol )
        xCellSize = Q( jDetGeo + L1GEOINFsx ) / FLOAT( nX )
        yCellSize = Q( jDetGeo + L1GEOINFsy ) / FLOAT( nY )
        IQ(HQL1SE_NAME_L()) = iDetectorName(iLayer)
        IQ(IQL1SE_LAY_L() ) = iLayer
        IQ(IQL1SE_SEC_L() ) = iSection
        IQ(IQL1SE_NC_L()  ) = nX * nY
        IQ(IQL1SE_NX_L()  ) = nX
        IQ(IQL1SE_NY_L()  ) = nY
         Q( QL1SE_X0_L()  ) = Q( jDetGeo + L1GEOINFx0 )
         Q( QL1SE_Y0_L()  ) = Q( jDetGeo + L1GEOINFy0 )
         Q( QL1SE_SX_L()  ) = Q( jDetGeo + L1GEOINFsx )
         Q( QL1SE_SY_L()  ) = Q( jDetGeo + L1GEOINFsy )
         Q( QL1SE_CSX_L() ) = Q( jDetGeo + L1GEOINFsx )
     &                             / FLOAT( nX )
         Q( QL1SE_CSY_L() ) = Q( jDetGeo + L1GEOINFsy )
     &                             / FLOAT( nY )
         Q( QL1SE_Z_L()   ) = Q( jDetGeo + L1GEOINFz  )
        IQ(IQL1SE_FC_L()  ) = NL1CE() + 1
        nCell = 0
        DO iX = 1 , nX
         DO iY = 1 , nY
          nCell = nCell + 1
c*  "Info" - the hit format-mask for the required Cell
          IF( NL1SE()    .GE. 2**16 )THEN
ctmp           C78='L1HPTIN,NL1SE()  Info Overflowed!'
ctmp           CALL CH78BI (NL1SE())
ctmp           CALL ME78AP
           WRITE(*,*)'L1HPTIN,NL1SE()  Info Overflowed!'
          ENDIF
          IF( iX       .GT. 2**8 )THEN
ctmp           C78='L1HPTIN,iX     Info Overflowed!'
ctmp           CALL CH78BI (iX)
ctmp           CALL ME78AP
           WRITE(*,*)'L1HPTIN,iX  Info Overflowed!'
          ENDIF
          IF( iY       .GT. 2**8 )THEN
ctmp           C78='L1HPTIN,iY     Info Overflowed!'
ctmp           CALL CH78BI (IY)
ctmp           CALL ME78AP
           WRITE(*,*)'L1HPTIN,iX  Info Overflowed!'
          ENDIF
          CALL SBYT( NL1SE()  , Info ,  1 , 16 )
          CALL SBYT( iX       , Info , 17 ,  8 )
          CALL SBYT( iY       , Info , 25 ,  8 )
ctmp          CALL MMBOOK( JL1CE , 1 )
          IF( N_F(JL1CE).LT.1)THEN
           CALL UTETAB(IXCONS,JL1CE,10000)
          ENDIF
          IQ( JL1CE + 2      ) = IQ(JL1CE+2)+1
          IQ(IQL1CE_INFO_L() ) = Info
         ENDDO
        ENDDO
        IQ(IQL1SE_LC_L()   ) = NL1CE()
       ENDDO
      ENDDO

      CALL UTCTAB(IXCONS,JL1SE)
      CALL UTCTAB(IXCONS,JL1CE)

C*    Try to read the table of coincidence from file

ctmp      CALL IOFIND( 'L1PT' , LUN )

ctmp      IF( LUN .LE. 0 .OR. LUN .GE. 99 ) THEN
ctmp       C78 = 'L1HPTin::==> no Unit for a Table File!'
ctmp       CALL ME78AP
ctmp       GO TO 50
ctmp      ENDIF

ctmp      CALL IODECL( 'L1PL' , LUN , High_Pt_Table_File_Name )

C*    Try to use the old file

ctmp      CALL IOOPEN( LUN , 'BO' ,  Lrecl , IOS )
ctmp      IF( IOS .NE. 0 ) THEN
ctmp       C78 = 'L1HPTin::==> Error Open OLD Unit for a Table-File!'
ctmp       CALL ME78AP
ctmp       GO TO 50
ctmp      ENDIF
C*
ctmp      CHDIR='High-PT_Table'
ctmp      CALL RZFILE( LUN , CHDIR , 'S' )
ctmp      IF( IQUEST(1) .NE. 0 ) THEN
ctmp       C78 = 'L1HPTin::==> Error RZFILE for a Table-File!'
ctmp       CALL ME78AP
ctmp       GO TO 50
ctmp      ENDIF


      INQUIRE( FILE=High_Pt_Table_File_Name, EXIST=IEXIST )

      IF( .NOT. IEXIST ) THEN
       WRITE(L1LUNprn,*)'File ',High_Pt_Table_File_Name,' is not found'
       CALL RZOPEN( L1HPTlun , CHDIR ,
     &  High_Pt_Table_File_Name ,
     &  'NXPW' , 1024 , ISTATZ )
       CALL RZLOGL( L1HPTlun , 2 )
       CALL RZMAKE( L1HPTlun , CHDIR , 1 , 'H' ,
     &  'PTObject' , 64000 , 'X'                 )
       CALL RZEND( CHDIR )
       CLOSE( L1HPTlun )
       GO TO 50
      ENDIF

      CALL RZOPEN( L1HPTlun , CHDIR ,
     & High_Pt_Table_File_Name ,
     &'UXPW' , 1024 , ISTATZ )
      CALL RZFILE( L1HPTlun , CHDIR , 'UX' )
      IF( iQUEST(1) .NE. 0)THEN
       WRITE(L1LUNprn,*)'L1HPTin,Error in Read ''Geom'' Structure'
       GO TO 40
      ENDIF
c      CALL RZLOGL( L1HPTlun , 2 )
C*
      iCycle = 0
      IF(BAVALID(JUSER,0))CALL MZDROP(IXCONS,JUSER,'L')

      CALL RZIN(IXCONS,JUSER,1,'SECT',iCycle,'D')

      IF( iQUEST(1) .NE. 0 )THEN
ctmp       C78 = 'L1HPTin::==> Error read from Table-File '
ctmp       CALL CH78BC ('SECT')
ctmp       CALL ME78AP
       IF(BAVALID(JUSER,0))CALL MZDROP (IXCONS,JUSER,'L')
       GO TO 40
      ENDIF

      IF( N_U(JUSER).NE.N_U(JL1SE) .OR.
     &    N_C(JUSER).NE.N_C(JL1SE))THEN
ctmp       C78 = 'L1HPTin::==> GEOMETRY DOES NOT COINCIDE '
ctmp       CALL CH78BC ('SECT')
ctmp       CALL ME78AP
       WRITE(L1LUNprn,*)'L1HPTin::==> GEOMETRY DOES NOT COINCIDE'
       IF(BAVALID(JUSER,0))CALL MZDROP(IXCONS,JUSER,'L')
       GO TO 40
      ENDIF
      DO  I = 1 , NL1SE()
       DO J = 1 , NCL1SE()
        IF(I_V(J,I,JL1SE).NE.
     &     I_V(J,I,JUSER))THEN
ctmp         C78 = 'L1HPTin::==> GEOMETRY DOES NOT COINCIDE '
ctmp         CALL CH78BC ('SECT')
ctmp         CALL ME78AP
         WRITE(L1LUNprn,*)'L1HPTin::==> GEOMETRY DOES NOT COINCIDE'
         IF(BAVALID(JUSER,0))CALL MZDROP(IXCONS,JUSER,'L')
         GO TO 40
        ENDIF
       ENDDO
      ENDDO

      iCycle = 0
      IF(BAVALID(JUSER,0))CALL MZDROP(IXCONS,JUSER,'L')
      CALL RZIN(IXCONS,JUSER,1,'CONN',iCycle,'D')
      IF( iQUEST(1) .NE. 0 )THEN
ctmp       C78 = 'L1HPTin::==> Error read from Table-File '
ctmp       CALL CH78BC ('CONN')
ctmp       CALL ME78AP
       WRITE(L1LUNprn,*)'L1HPTin::==> Error read from Table File'
       IF(BAVALID(JUSER,0))CALL MZDROP(IXCONS,JUSER,'L')
       GO TO 40
      ENDIF

      IF(BAVALID(JUSER,0))CALL MZDROP(IXCONS,JUSER,'L')
      CALL RZIN(IXCONS,JUSER,1,'CELL',iCycle,'D')
      IF( iQUEST(1) .NE. 0 )THEN
ctmp       C78 = 'L1HPTin::==> Error read from Table-File '
ctmp       CALL CH78BC ('CONN')
ctmp       CALL ME78AP
       WRITE(L1LUNprn,*)'L1HPTin::==> Error read from Table File'
       IF(BAVALID(JUSER,0))CALL MZDROP(IXCONS,JUSER,'L')
       GO TO 40
      ENDIF
      IF(BAVALID(JUSER,0))CALL MZDROP(IXCONS,JUSER,'L')

      IF(BAVALID(JL1CE,0))CALL MZDROP(IXCONS,JL1CE,'L')
      CALL RZIN(IXCONS,JL1CE,1,'CELL',iCycle,'D')
      IF( iQUEST(1) .NE. 0 )THEN
ctmp       C78 = 'L1HPTin::==> Error read from Table-File '
ctmp       CALL CH78BC ('CONN')
ctmp       CALL ME78AP
       WRITE(L1LUNprn,*)'L1HPTin::==> Error read from Table File'
       IF(BAVALID(JL1CE,0))CALL MZDROP(IXCONS,JL1CE,'L')
       GO TO 40
      ENDIF


      IF(BAVALID(JLXCC,0))CALL MZDROP(IXCONS,JLXCC,'L')
      CALL RZIN(IXCONS,JLXCC,1,'CONN',iCycle,'D')

      IF( iQUEST(1) .NE. 0 )THEN
ctmp       C78 = 'L1HPTin::==> Error read from Table-File '
ctmp       CALL CH78BC ('CONN')
ctmp       CALL ME78AP
       WRITE(L1LUNprn,*)'L1HPTin::==> Error read from Table File'
       IF(BAVALID(JLXCC,0))CALL MZDROP(IXCONS,JLXCC,'L')
       GO TO 40
      ENDIF

      LQ( JLXCC - 1 ) = JL1CE
      LQ( JLXCC - 2 ) = JL1CE

c      CALL RZLDIR('//' , ' ' )
c      CALL RZLDIR('//'//CHDIR , ' ' )
c      CALL RZLDIR(' '  , ' ' )
      CALL RZEND(CHDIR)

ctmp      CALL IOCLOS( LUN )

      GO TO 60
40    CONTINUE
c      CALL RZLDIR('//' , ' ' )
c      CALL RZLDIR('//'//CHDIR , ' ' )
c      CALL RZLDIR(' '  , ' ' )
      CALL RZEND( CHDIR )
      CLOSE( L1HPTlun )
50    CONTINUE
C*    Fill CONNECTION data structure

      WRITE(L1LUNprn,*)'L1HPTin: CONNECTIONS reinitialization ',
     &     'will take some time'
      WRITE(L1LUNprn,*)'         please do not worry and wait...'

      IF(BAVALID(JLXCC,0))CALL MZDROP(IXCONS,JLXCC,'L')
      CALL UTBREL(IXCONS,JLXCC,'LXCC',JL1CE,2,JL1CE,3,1000)

      DO iLay1 = 1 , nLayer - 1
       iLay2 = iLay1 + 1
       DO iSection1 = 1 , NL1SE()
        IF(IL1SE_LAY(iSection1).EQ.iLay1)THEN
         xCell1Size  = FL1SE_CSX( iSection1 )
         yCell1Size  = FL1SE_CSY( iSection1 )
         zCell1Start = FL1SE_Z  ( iSection1 )
         DO iSection2 = 1 , NL1SE()
          IF(IL1SE_LAY(iSection2).EQ.iLay2)THEN
           xCell2Size  = FL1SE_CSX( iSection2 )
           yCell2Size  = FL1SE_CSY( iSection2 )
           zCell2Start = FL1SE_Z  ( iSection2 )
           zScaleFactor =
     &        ( zCell2Start + zShift ) /
     &        ( zCell1Start + zShift )
           yCellSize = yCell1Size * zScaleFactor
           xCellSize = xCell1Size * zScaleFactor
           yCellSize = MAX(yCell2Size,yCellsize)
           xCellSize = MAX(xCell2Size,xCellsize)
           DO iCell1 = IL1SE_FC( iSection1 ) ,
     &                 IL1SE_LC( iSection1 )
            xCell1Start = FL1CE_X0 ( iCell1 ) +
     &              0.5 * FL1CE_SX ( iCell1 )
            yCell1Start = FL1CE_Y0 ( iCell1 ) +
     &              0.5 * FL1CE_SY ( iCell1 )
            xCell1Projection = xCell1Start *
     &                          zScaleFactor
            yCell1Projection = yCell1Start *
     &                         zScaleFactor
            DO iCell2 = IL1SE_FC( iSection2 ) ,
     &                  IL1SE_LC( iSection2 )
             xCell2Start = FL1CE_X0 ( iCell2 ) +
     &               0.5 * FL1CE_SX ( iCell2 )
             yCell2Start = FL1CE_Y0 ( iCell2 ) +
     &               0.5 * FL1CE_SY ( iCell2 )
             dX = xCell2Start - xCell1Projection
             dY = yCell2Start - yCell1Projection
c*           Pretrigger Conditions !!!!
             IF(  ABS( dY ) .LE. 0.6 * yCellSize ) THEN
c*            Coincide on Y !!!!
              IF( ABS( dX ) .LE. 1.1 * xCellSize ) THEN
c*             Coincide on X within 3 Cells in
c*             the case of all layers !!!!
c*             If the last Layer has a shift - only 2 Cells !!!!
c*             The "first" pretrigger confition is fullfiled !!!!
ctmp               CALL MMBREL( JLXCC , iCell1 , iCell2 )
               CALL UTEREL(IXCONS,JLXCC,iCell1,iCell2)
              ENDIF
             ENDIF
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDIF
       ENDDO
      ENDDO

C*    Save the data structures into file

ctmp      CALL IOFIND( 'L1PT' , LUN )

ctmp      IF( LUN .LE. 0 .OR. LUN .GE. 99 ) THEN
ctmp       C78 = 'L1HPTin::==> no Unit for a Table File!'
ctmp       CALL ME78AP
ctmp       GO TO 50
ctmp     ENDIF

ctmp      CALL IODECL( 'L1PL' , LUN , High_Pt_Table_File_Name )

C*    Try to use the old file

ctmp      CALL IOOPEN( LUN , 'BO' ,  Lrecl , IOS )
ctmp      IF( IOS .NE. 0 ) THEN
ctmp       C78 = 'L1HPTin::==> Error Open OLD Unit for a Table-File!'
ctmp       CALL ME78AP
ctmp       C78 = 'L1HPTin::==> Try to Open NEW file for a Table-file!'
ctmp       CALL ME78AP
ctmp       CALL IOOPEN( LUN , 'BN' ,  Lrecl , IOSS )
ctmp       IF( IOSS .NE. 0 )THEN
ctmp        C78 ='L1HPTin::==> fatal file error !'
ctmp        CALL ME78AP
ctmp        RETURN
ctmp       ENDIF
ctmp       CALL RZMAKE( LUN,CHDIR,1,'H','HIGH-PT_OBJECT',NREC,' ')
ctmp       IF( IQUEST(1) .NE. 0 ) THEN
ctmp        C78 = 'L1HPTin::==> Error RZMAKE for a Table-File!'
ctmp        CALL ME78AP
ctmp        GO TO 80
ctmp       ENDIF
ctmp      ELSE
ctmp       CHDIR='High-PT_Table'
ctmp       CALL RZFILE( LUN , CHDIR , 'S' )
ctmp       IF( IQUEST(1) .NE. 0 ) THEN
ctmp        C78 = 'L1HPTin::==> Error RZFILE for a Table-File!'
ctmp        CALL ME78AP
ctmp        GO TO 80
ctmp       ENDIF
ctmp      ENDIF
C*

      CALL RZOPEN( L1HPTlun , CHDIR ,
     & High_Pt_Table_File_Name ,
     & 'UXPW' , 1024 , ISTATZ )
c      CALL RZLOGL( L1HPTlun , 2 )
      CALL RZFILE( L1HPTlun , CHDIR , 'UX' )
c      CALL RZLDIR('//' , ' ' )
c      CALL RZLDIR('//'//CHDIR , ' ' )
c      CALL RZLDIR(' '  , ' ' )
      CALL RZOUT( IXCONS , JL1CE , 'CELL' , iCycle , ' ' )
      IF( iQUEST(1) .NE. 0 ) THEN
ctmp       C78='L1HPTin::==> Error writing the object:'
ctmp       CALL CH78BC( 'CELL' )
ctmp       CALL ME78AP
       WRITE(L1LUNprn,*)'L1HPTin::==> Error writing the object: CELL'
      ENDIF
      CALL RZOUT( IXCONS , JL1SE , 'SECT' , iCycle , ' ' )
      IF( iQUEST(1) .NE. 0 ) THEN
ctmp       C78='L1HPTin::==> Error writing the object:'
ctmp       CALL CH78BC( 'SECT' )
ctmp       CALL ME78AP
       WRITE(L1LUNprn,*)'L1HPTin::==> Error writing the object: SECT'
      ENDIF
      CALL RZOUT( IXCONS , JLXCC , 'CONN' , iCycle , ' ' )
      IF( iQUEST(1) .NE. 0 ) THEN
ctmp       C78='L1HPTin::==> Error writing the object:'
ctmp       CALL CH78BC( 'CONN' )
ctmp       CALL ME78AP
       WRITE(L1LUNprn,*)'L1HPTin::==> Error writing the object: CONN'
      ENDIF

c      CALL RZLDIR('//' , ' ' )
c      CALL RZLDIR('//'//CHDIR , ' ' )
c      CALL RZLDIR(' '  , ' ' )
      CALL RZPURG( 1 )
c      CALL RZLDIR('//' , ' ' )
c      CALL RZLDIR('//'//CHDIR , ' ' )
c      CALL RZLDIR(' '  , ' ' )
      CALL RZEND( CHDIR )
      CLOSE( L1HPTlun )
60    CONTINUE


      DO i = 1 , NL1CE()
       IF( IL1CE_LAY(i) .ne. 3 ) THEN
        IF( PL1Ce_CEL1(i) .EQ. 0 ) THEN
c         print *,' conn0!! ',i,Il1CE_LAY(i),
c     &                         IL1CE_SEC(i),
c     &   fl1ce_x0(i),
c     &   fl1ce_y0(i),
c     &   fl1ce_sx(i),
c     &   fl1ce_sy(i)


        ENDIF
       ENDIF
      ENDDO
      RETURN
      END








