*CMZ :  2.01/01 08/12/95  12.06.42  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   26/10/95

      SUBROUTINE LIMTR1 (ITR, IMAR, CTPL)

************************************************************************
*
* Description: list one track in MTRA
*
* Called from: LIMTRA
*
* External references:
*
* Argument in/out description
*   ITR    in
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/TOPP.fi"

      INTEGER I, ITR, IMAR, NMI, NMC, LENOCC
      CHARACTER CTPL*(*), CN*12

#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/TOPP.ff"

      WRITE (C78, '(I5)')  ITR

      IF (JMTRA .EQ. 0 .OR. ITR .LE. 0 .OR. ITR .GT. NMTRA())  THEN

        C78(6:) =  'LIMTR1: invalid MTRA number'

      ELSE

        NMI = 0
        I = PMTRX_MIMP(ITR)
 10     IF (I .EQ. 0)  GO TO 20
        NMI = NMI + 1
        I = XMTRX_MIMP(I)
        GO TO 10

 20     NMC = 0
        I = PMTRX_MCAL(ITR)
 30     IF (I .EQ. 0)  GO TO 40
        NMC = NMC + 1
        I = XMTRX_MCAL(I)
        GO TO 30

 40     I = 3
        IF (ABS (FMTRA_PX(ITR)) .LT. 1.)  I = -3
        CALL CHFTOC (FMTRA_PX(ITR), I, '*', C78( 7:13))
        I = 3
        IF (ABS (FMTRA_PY(ITR)) .LT. 1.)  I = -3
        CALL CHFTOC (FMTRA_PY(ITR), I, '*', C78(15:21))
        I = 3
        IF (ABS (FMTRA_PZ(ITR)) .LT. 1.)  I = -3
        CALL CHFTOC (FMTRA_PZ(ITR), I, '*', C78(23:29))
        CALL CHFTOC (FMTRX_MASS(ITR), 2, '*', C78(31:36))
        CALL CHFTOC (FMTRX_LENG(ITR), 2, '*', C78(38:43))
        WRITE (C78(45:), 1001)  IMTRA_FLAG(ITR), OMTRX_BVER(ITR),
     +    NMI, NMC

        CALL CHHTOC (IQ(HQTOPP_NAME(1,OMTRA_TOPP(ITR))), CN)
        I = MIN (IMAR + 59, 79 - LENOCC (CN))
        C78(59:) = '. . . . . . . . . . '
        C78(I:) = CN

      END IF

      CALL ME78SP (CTPL)

 1001 FORMAT (I1,I5,I4,I3)

      END

************************************************************************
* End of LIMTR1
************************************************************************
