*CMZ :  2.01/01 19/12/95  15.38.34  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   26/10/95

      SUBROUTINE LIMVE1 (IVE, CTPL)

************************************************************************
*
* Description: list one vertex in MVER
*
* Called from: LIMVER
*
* External references:
*
* Argument in/out description
*   IVE    in     vertex number in MVER
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MVER.fi"
#include "auto/MVEX.fi"

      INTEGER I, IVE
      CHARACTER CTPL*(*)

#include "arte/Arte.ff"
#include "auto/MVER.ff"
#include "auto/MVEX.ff"

      C78 = ' '

      IF (JMVER .EQ. 0 .OR. IVE .LE. 0 .OR. IVE .GT. NMVER())  THEN

        C78 =  'LIMVE1: invalid MVER number'

      ELSE

        WRITE (C78, '(I5)')   OMVER_BTRA(IVE)
        I = 3
        IF (ABS (FMVER_X(IVE)) .LT. 1.)  I = -3
        CALL CHFTOC (FMVER_X(IVE), I, '*', C78( 7:13))
        I = 3
        IF (ABS (FMVER_Y(IVE)) .LT. 1.)  I = -3
        CALL CHFTOC (FMVER_Y(IVE), I, '*', C78(15:21))
        I = 3
        IF (ABS (FMVER_Z(IVE)) .LT. 1.)  I = -3
        CALL CHFTOC (FMVER_Z(IVE), I, '*', C78(23:29))
        WRITE (C78(33:), 1001)  OMVEX_MCME(IVE), IMVER_FLAG(IVE), IVE

      END IF

      CALL ME78SP (CTPL)

 1001 FORMAT (I1,I2,I15)

      END

************************************************************************
* End of LIMVE1
************************************************************************
