*CMZ :          23/04/96  15.57.05  by  Hartwig Albrecht
*CMZ :  2.01/02 26/01/96  20.14.28  by  Hartwig Albrecht
*CMZ :  2.01/01 13/11/95  15.27.53  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE LITITL (CTPL)

************************************************************************
*
* Description: print program title
*
* Called from: initialization routines
*
* External references: MESELP, LIHEAD , VIZPRI 
*
* Argument in/out description
*   CTPL   in     printer destination 'tpl'
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"

      CHARACTER CSTAR*78, C1(78)*1, CTPL*(*)
      EQUIVALENCE (C1(1),CSTAR)

      CHARACTER*20  CUSER
      CHARACTER*20  CHBVERS
      CHARACTER*78  CHB 
      CHARACTER*78  CHBSCRATCH 
      CHARACTER*78  CPWD 
      INTEGER       LENOCC , i 
      EXTERNAL      LENOCC 

      DATA C1 /'*',77*'-'/

#include "arte/Arte.ff"

      CALL UTPOPT( CTPL ) 

      CALL MESELP (CSTAR, CTPL)

      CHBVERS=' ' 
      CALL GETENV( 'HBVERS'    , CHBVERS    )
      IF( LENOCC(CHBVERS) .GE. 1 )THEN
      DO  I = 1, 3
       IF (LIOTPL(I) .GT. 0)CALL VIZPRI(LIOTPL(I),
     & CHBVERS(1:MIN(4,LENOCC(CHBVERS))))
       IF( LENOCC( CHBVERS ) .GE. 6 )THEN  
        IF (LIOTPL(I) .GT. 0)CALL VIZPRI(LIOTPL(I),CHBVERS(6:10))
       ENDIF 
       IF( LENOCC( CHBVERS ) .GE. 12 )THEN  
        IF (LIOTPL(I) .GT. 0)CALL VIZPRI(LIOTPL(I),CHBVERS(12:17))
       ENDIF 
       IF( LENOCC( CHBVERS ) .GE. 19 )THEN  
        IF (LIOTPL(I) .GT. 0)CALL VIZPRI(LIOTPL(I),
     & CHBVERS(19:LEN(CHBVERS)))
       ENDIF 
      ENDDO 
      ENDIF 

      CALL MESELP (CSTAR, CTPL)
      CALL MESELP ('*', CTPL)
      C78 = 'HERA-B Event Analysis and Reconstruction Tool ARTE'
      CALL CHCENT (C78)
      CALL MESELP ('*' // C78, CTPL)

      C78 = 'ARTE version:'
      WRITE (C78(15:22), 1001)  ARTEVERS
      CALL CHCENT (C78)
      CALL MESELP ('*' // C78, CTPL)

      IF (LUNDVERS .NE. 0.)  THEN
        C78 = 'LUND version:'
        WRITE (C78(15:22), 1001)  LUNDVERS
        CALL CHCENT (C78)
        CALL MESELP ('*' // C78, CTPL)
      END IF

      IF (GEANVERS .NE. 0.)  THEN
        C78 = 'HBGEANT version:'
        WRITE (C78(16:23), 1001)  GEANVERS
        CALL CHCENT (C78)
        CALL MESELP ('*' // C78, CTPL)
      END IF

      IF (RECOVERS .NE. 0.)  THEN
        C78 = 'RECO version:'
        WRITE (C78(15:22), 1001)  RECOVERS
        CALL CHCENT (C78)
        CALL MESELP ('*' // C78, CTPL)
      END IF

      CALL LIHLIN (CTPL)

      C78='  ' 
      CALL CH78BC ('Source:')
      CALL CH78BC (SRCNAME)
      CALL CHCENT (C78)
      CALL MESELP ('*' // C78, CTPL)

      C78 = 'Bintype:'
      CALL CH78BC (BINTYPE)
      CALL CH78BC ('Host:')
      CALL CH78BC (HOSTNAME)
      CALL CH78BC ('at')
      CALL CH78BC (INSTNAME)
      CALL CH78BI (INSTNUM)
      CALL CHCENT (C78)
      CALL MESELP ('*' // C78, CTPL)

      C78='Environment:'
      CALL CHCENT( C78 ) 
      CALL MESELP ('*' // C78, CTPL)
 
      CHB=' ' 
      CALL GETENV( 'HB'        , CHB        )
      C78='     $HB='
      IF( LENOCC(CHB) .EQ.0 )CHB=' not defined '  
      CALL CH78AC( CHB(1:LENOCC(CHB))) 
      CALL CHCENT (C78)
      CALL MESELP ('*' // C78, CTPL)
    
      CHBVERS=' ' 
      CALL GETENV( 'HBVERS'    , CHBVERS    )
      C78='     $HBVERS='
      IF( LENOCC(CHBVERS) .EQ.0 )CHBVERS=' not defined '  
      CALL CH78AC( CHBVERS(1:LENOCC(CHBVERS))) 
      CALL CHCENT (C78)
      CALL MESELP ('*' // C78, CTPL)

      CHBSCRATCH=' ' 
      CALL GETENV( 'HBSCRATCH' , CHBSCRATCH )
      C78='     $HBSCRATCH='
      IF( LENOCC(CHBVERS) .EQ.0 )CHBSCRATCH=' not defined '  
      CALL CH78AC( CHBSCRATCH(1:LENOCC(CHBSCRATCH))) 
      CALL CHCENT (C78)
      CALL MESELP ('*' // C78, CTPL)

      CUSER=' ' 
      CALL GETENV( 'USER'      , CUSER      )
      C78='     $USER='
      IF( LENOCC(CUSER) .EQ.0 )CUSER=' not defined '  
      CALL CH78AC( CUSER(1:LENOCC(CUSER))) 
      CALL CHCENT (C78)
      CALL MESELP ('*' // C78, CTPL)

      CPWD=' ' 
      CALL GETENV( 'PWD'       , CPWD       ) 
      C78='     $PWD='
      IF( LENOCC(CPWD) .EQ.0 )CPWD=' not defined '  
      CALL CH78AC( CPWD(1:LENOCC(CPWD))) 
      CALL CHCENT (C78)
      CALL MESELP ('*' // C78, CTPL)

    
      CALL MESELP ('*', CTPL)
      CALL MESELP (CSTAR, CTPL)

 
 1001 FORMAT (F8.4)

      END

************************************************************************
* End of LITITL
************************************************************************
