*
*  B.Fominykh  11.07.97
*
* pad coincidences are used as basis for track reconstruction
      SUBROUTINE MURPAD
C-    =================
      IMPLICIT NONE
*
#include "murec/MUCPAR.fi"
#include "murec/MUCONT.fi"
#include "murec/MUCTAB.fi"
#include "murec/MUCZDT.fi"
#include "arte/Arte.fi"
      INTEGER I,J,I1,I2,JC1,JC2,ISL,IS,IRL,ICL,JCL,JH
      REAL CHX,CHY,FAC,X11,X12,Y11,Y12,XH1,XH2,YH1,YH2
      INTEGER IRLM(4),NPADC(2),IPADC(4,NPADCM),IPADW(4)
      DATA IRLM / 20, 24, 30, 34 /
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
* check-point - no pads, nothing to do
      IF(NMUACL(IRLM(1)).LE.0.AND.NMUACL(IRLM(1)+1).LE.0.AND.
     +   NMUACL(IRLM(2)).LE.0.AND.NMUACL(IRLM(2)+1).LE.0) GOTO 999
      IF(NMUACL(IRLM(3)).LE.0.AND.NMUACL(IRLM(3)+1).LE.0.AND.
     +   NMUACL(IRLM(4)).LE.0.AND.NMUACL(IRLM(4)+1).LE.0) GOTO 999
      IF(JTMP8.LE.0) GOTO 999
      IF(IQ(JTMP8+1).LE.0) GOTO 999
      IF(IQ(JTMP8+2).LE.0) GOTO 999
*
      NPADC(1)=0
      NPADC(2)=0
* double candidates in MU3, MU4
      DO 20 ISL=1,4
        IRL=IRLM(ISL)
        IF(NMUACL(IRL).GT.0) THEN
        JC1=JTMP8+IQ(JTMP8+1)*(JCLPT1(IRL)-2)+2
        DO 12 I1=1,NMUCLL(IRL)
          JC1=JC1+IQ(JTMP8+1)
* is the cluster active?
          IF(IQ(JC1+1).NE.1) GOTO 12
          IF(NMUACL(IRL+1).GT.0) THEN
            JC2=JTMP8+IQ(JTMP8+1)*(JCLPT1(IRL+1)-2)+2
            DO 11 I2=1,NMUCLL(IRL+1)
              JC2=JC2+IQ(JTMP8+1)
* is the cluster active?
              IF(IQ(JC2+1).NE.1) GOTO 11
* search for double candidates
              CHX=(Q(JC1+8)-Q(JC2+8))**2/(Q(JC1+11)**2+Q(JC2+11)**2)
              IF(CHX.GT.CHPADX) GOTO 11
              CHY=(Q(JC1+9)-Q(JC2+9))**2/(Q(JC1+12)**2+Q(JC2+12)**2)
              IF(CHY.GT.CHPADY) GOTO 11
              IS=(ISL+1)/2
              I=NPADC(IS)+1
              NPADC(IS)=I
              IPADC(2*IS-1,I)=JCLPT1(IRL)+I1-1
              IPADC(2*IS,I)=JCLPT1(IRL+1)+I2-1
              IQ(JC1+17)=2
              IQ(JC2+17)=2
              IF(NPADC(ISL).GE.NPADCM) GOTO 21
 11         CONTINUE
          ENDIF
 12     CONTINUE
      ENDIF
 20   CONTINUE
 21   CONTINUE
*
* single candidates in MU3,MU4
      DO 40 ISL=1,4
        IRL=IRLM(ISL)
        IF(NMUACL(IRL)+NMUACL(IRL+1).GT.0) THEN
        DO 32 I1=1,NMUCLL(IRL)+NMUCLL(IRL+1)
          IF(NMUCLL(IRL).GT.0) THEN
      JC1=JTMP8+IQ(JTMP8+1)*(JCLPT1(IRL)+I1-2)+2
          ELSE
      JC1=JTMP8+IQ(JTMP8+1)*(JCLPT1(IRL+1)+I1-2)+2
          ENDIF
* is the cluster active?
          IF(IQ(JC1+1).NE.1)  GOTO 32
* been cluster used? 
          IF(IQ(JC1+17).GT.0) GOTO 32
          IS=(ISL+1)/2
          I=NPADC(IS)+1
          NPADC(IS)=I
          IF(I1.LE.NMUCLL(IRL)) THEN
            IPADC(2*IS-1,I)=JCLPT1(IRL)+I1-1
            IPADC(2*IS,I)=0
          ELSE
            IPADC(2*IS-1,I)=0
      IPADC(2*IS,I)=JCLPT1(IRL+1)+(I1-NMUCLL(IRL))-1
          ENDIF
          IQ(JC1+17)=1
          IF(NPADC(ISL).GE.NPADCM) GOTO 41
 32     CONTINUE
      ENDIF
 40   CONTINUE
 41   CONTINUE
*
      IF(IPRLG.GE.4) THEN
      DO IS=1,2
        IF(NPADC(IS).GT.0) THEN
          WRITE(LLOGF,1001) IS,NPADC(IS),
     +      (IPADC(2*IS-1,J),IPADC(2*IS,J),J=1,NPADC(IS))
 1001     FORMAT(1X,I2,I4,' cl(1,2):',100(2I4,4X))
        ELSE
          WRITE(LLOGF,1002) IS
 1002     FORMAT(1X,I2,'   no selected pads')
        ENDIF
      ENDDO
      ENDIF
*
* relation between pads MU3 and MU4
      IF(NPADC(1).LE.0.OR.NPADC(2).LE.0) GOTO 999
      FAC=SQRT(12.)
* loops over MU3 clusters
      DO 100 I1=1,NPADC(1)
        X11=1000.
        X12=-1000.
        Y11=1000.
        Y12=-1000.
        DO I=1,2
          ICL=IPADC(I,I1)
          JCL=JTMP8+IQ(JTMP8+1)*(ICL-1)+2
          DO J=IQ(JCL+15),IQ(JCL+16)
            JH=JTMP9+IQ(JTMP9+1)*(J-1)+2
            XH1=Q(JH+8)-FAC*Q(JH+11)
            IF(XH1.LT.X11) X11=XH1
            XH2=Q(JH+8)+FAC*Q(JH+11)
            IF(XH2.GT.X12) X12=XH2
            YH1=Q(JH+9)-FAC*Q(JH+12)
            IF(YH1.LT.Y11) Y11=YH1
            YH2=Q(JH+9)+FAC*Q(JH+12)
            IF(YH2.GT.Y12) Y12=YH2
          ENDDO
        ENDDO
* zone of interest in MU4
        X11=X11-DXPZON        
        X12=X12+DXPZON        
        Y11=Y11-DYPZON        
        Y12=Y12+DYPZON        
* loops over MU4 clusters
        DO 80 I2=1,NPADC(2)
          DO I=1,2
            ICL=IPADC(2+I,I2)
            JCL=JTMP8+IQ(JTMP8+1)*(ICL-1)+2
            IF(X11-Q(JCL+8).LT.Q(JCL+11).AND.
     +         Q(JCL+8)-X12.LT.Q(JCL+11).AND.
     +         Y11-Q(JCL+9).LT.Q(JCL+12).AND.
     +         Q(JCL+9)-Y12.LT.Q(JCL+12)) GOTO 60
          ENDDO
          GOTO 80
  60      CONTINUE

          DO I=1,2
            IPADW(I)=IPADC(I,I1)
            IPADW(2+I)=IPADC(2+I,I2)
          ENDDO
* check-point
          IF(IPADW(1).EQ.IPADW(3).AND.
     +       IPADW(2).EQ.IPADW(4)) GOTO 80
          IF(IPADW(1).EQ.IPADW(4).AND.
     +       IPADW(2).EQ.IPADW(3)) GOTO 80

* coincidence of pads
        IF(IPRSC.GE.3)
     +   PRINT 1011,(IPADW(I),I=1,4)
        IF(IPRLG.GE.3)
     +   WRITE(LLOGF,1011) (IPADW(I),I=1,4)
 1011   FORMAT(1X,'coincidence of pads:',4I4)
*
          CALL MURWIR(IPADW)
*
  80    CONTINUE
 100  CONTINUE
*
 999  CONTINUE
      RETURN
      END
