*CMZ :  4.04/01 26/03/96  14.28.09  by  Rainer Mankel
*CMZ :  4.03/00 13/07/95  16.38.57  by  Rainer Mankel
*CMZ :  4.01/00 10/04/95  18.47.21  by  Rainer Mankel
*CMZ :  4.00/00 30/03/95  19.12.57  by  Rainer Mankel
*CMZ :  3.03/01 18/01/95  09.57.55  by  Rainer Mankel
*CMZ :  2.04/02 09/04/94  18.21.23  by  Rainer Mankel
*CMZ :  2.04/00 06/04/94  18.57.47  by  Rainer Mankel
*CMZ :  2.02/04 06/02/94  14.00.20  by  Rainer Mankel
*-- Author :    Rainer Mankel   06/02/94

      subroutine tumclo(iih,nmx,nmcass,mcass)
*     **** locate MC particles associated with this hit
      implicit none
      integer nmx, iih, jaux, mimp
      integer iimimp, nmcass, mcass(nmx)
#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/HITB.fi"
#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/HITB.ff"

*     **** check if in allowed area
      if (iih.gt.iq(jhitb+2)) then
       print *,' () tumclo: invalid iih=', iih,
     +         ' #hits=', iq(jhitb+2)
       stop 'tumclo'
      endif

      nmcass = 0
*     **** loop over related MC particles
      do 10 iimimp=1,99
       if (iimimp.eq.1) then
        jaux = phitb_mimp(iih)
       else
        jaux = xhitb_mimp(jaux)
       endif
       if (jaux.eq.0) go to 11

       if (nmcass.lt.nmx) then
        mimp = mhitb_mimp(jaux)
        if (mimp.gt.0) then
         nmcass = nmcass + 1
         mcass(nmcass) = omimp_mtra( mimp )
        endif
       else
        print *,' () tumclo: mcass overflow '
        stop 'tumclo'
       endif
 10   continue

 11   continue

      end
