*CMZ :  4.01/00 01/10/95  20.14.39  by  Rainer Mankel
*CMZ :  4.00/02 28/09/95  16.34.24  by  Rainer Mankel
*-- Author :    Rainer Mankel   22/09/95

      subroutine dmout()

*     **** write domain structure to sequential file
      implicit none

#include "rang/zdomain.fi"
      integer ii, jj

      open(53,file='domain.dat',status='unknown', access='sequential')

*     **** write domains
      do ii=1,n_dm
       write(53,'(a4,6i8)') 'dm',
     +  ii,(domsl_dm(jj,ii),jj=1,maxsl_dm),scope_dm(ii),nwin_dm(ii),
     +  win1_dm(ii)
      enddo

*     **** write domain windows
      do ii=1,n_dw
       write(53,'(a4,6i6,2x,3i5,2x,3i5,2x,3i5,2x,4i5,6f10.3)') 'dw',
     +  ii,domain_dw(ii),plshad_dw(ii),secshad_dw(ii),
     +  prvwin_dw(ii),nxtwin_dw(ii),
     +  (nlayer_dw(jj,ii),jj=1,3),(layer1_dw(jj,ii),jj=1,3),
     +  (layerlst_dw(jj,ii),jj=1,3),
     +  nnavf_dw(ii),navf1_dw(ii),nnavb_dw(ii),navb1_dw(ii),
     +  xmin_dw(ii),xmax_dw(ii),ymin_dw(ii),
     +  ymax_dw(ii),zmin_dw(ii),zmax_dw(ii)
      enddo

*     **** write domain layers
      do ii=1,n_dl
       write(53,'(a4,2i6,2x,10i6)') 'dl',
     +  ii,laydom_dl(ii),win_dl(ii),wlayer_dl(ii),
     +  (nxtlay_dl(jj,ii),jj=1,3),
     +  (prvlay_dl(jj,ii),jj=1,3),
     +  nlayplane_dl(ii),layplane1_dl(ii)
      enddo

*     **** write layer planes
      do ii=1,n_dp
       write(53,'(a4,i6,2i6,2f8.2)') 'dp',
     +  ii,domlay_dp(ii),gede_dp(ii),umin_dp(ii),umax_dp(ii)
      enddo

*     **** write domain window navigation table
      do ii=1,n_dn
       write(53,'(a4,2i6)') 'dn',
     +  ii,wintarg_dn(ii)
      enddo

*     **** write domain layer seeding table
      do ii=1,nseedh_ds
       write(53,'(a4,i4,4x,2i6)') 'dsh', ii, (dlayh_ds(jj,ii),jj=1,2)
      enddo
      do ii=1,nseedv_ds
       write(53,'(a4,i4,4x,2i6)') 'dsv', ii, (dlayv_ds(jj,ii),jj=1,2)
      enddo

*     **** write domain gede translation
      do ii=1,maxgede_dg,5
       write(53,'(a4,i5,2x,5i6)') 'dg',ii,(dlayer_dg(jj),jj=ii,ii+4)
      enddo

      close(53)

      end
