*CMZ :  4.04/01 09/09/96  12.44.01  by  Rainer Mankel
*-- Author :    Rainer Mankel   09/09/96

      subroutine tfktparm()

*     **** KUIP interface to tftparm
      implicit none
      real pa(5),pamc(5),dpa(5),ch2mc,ex(5),dpanorm(5),fracmc
      integer it,imc,istat,i
      logical momentum
#include "arte/Arte.fi"
#include "auto/RTRA.fi"

#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/RTRA.ff"

      call kugeti(it)
      call tfremcn(it,imc,fracmc)

      if (imc.le.0) then
         print *,' () tfktparm: imc=',imc
         go to 999
      endif

      if (irtra_fit(it).le.1) then
         momentum = .false.     ! no momentum on this track
      else
         momentum = .true.      !    momentum on this track
      endif

      if (momentum) then
         call tftparm(it,imc,pa,pamc,dpa,dpanorm,ch2mc,istat)
      else
         call tftpar2(it,imc,pa,pamc,dpa,dpanorm,ch2mc,istat)
      endif

      if (istat.ne.0) then
         print *,' () tfktparm: istat=',istat
         go to 999
      endif

      do i=1,5
         ex(i) = sqrt(frtra_cvf(matrix_pack(i,i),it))
      enddo

*     **** printout
      if (momentum) then
         print 101, it, imc,
     +        (pamc(i), pa(i), ex(i), dpa(i), dpanorm(i),i=1,5),
     +        ch2mc, frtra_chi(it), irtra_hou(it)

 101     format(//
     +       '--------------------------------------------------------'/
     +       '| tftparm analysis it=',i4,
     +       '  mc=', i5,'                       |'/
     +       '|------------------------------------------------------|'/
     +       '|         MC        RC       e(RC)    MC-RC   (MC-RC)/e|'/
     +       '|  x=', 5f10.5, '|'/
     +       '|  y=', 5f10.5, '|'/
     +       '| mx=', 5f10.5, '|'/
     +       '| my=', 5f10.5, '|'/
     +       '|Q/p=', 5f10.5, '|'/
     +       '|------------------------------------------------------|'/
     +       '| ch2mc=', f10.2, '    chfit=', f10.2,
     +       '  #hits=', i3,'      |'/
     +       '--------------------------------------------------------'
     +       )

      else
         print 102, it, imc,
     +        (pamc(i), pa(i), ex(i), dpa(i), dpanorm(i),i=1,4),
     +        ch2mc, frtra_chi(it), irtra_hou(it)

 102     format(//
     +       '--------------------------------------------------------'/
     +       '| tftpar2 analysis it=',i4,
     +       '  mc=', i5,'                       |'/
     +       '|------------------------------------------------------|'/
     +       '|         MC        RC       e(RC)    MC-RC   (MC-RC)/e|'/
     +       '|  x=', 5f10.5, '|'/
     +       '|  y=', 5f10.5, '|'/
     +       '| mx=', 5f10.5, '|'/
     +       '| my=', 5f10.5, '|'/
     +       '|------------------------------------------------------|'/
     +       '| ch2mc=', f10.2, '    chfit=', f10.2,
     +       '  #hits=', i3,'      |'/
     +       '--------------------------------------------------------'
     +       )
      endif

      if (fracmc.lt.0.7) print '(/(a),f10.2/)',
     +     ' Warning: fracmc only ',fracmc

 999  end





