*CMZ :  1.00/01 27/06/96  16.05.32  by   Ivan Belyaev
*CMZ :  1.04/11 18/12/95  14.55.48  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.36.10  by  joerg f. rieling
*CMZ :  1.04/08 07/11/95  10.03.40  by  joerg f. rieling
*CMZ :  1.04/06 29/06/95  12.40.57  by  joerg f. rieling
*CMZ :  1.04/03 22/05/95  15.51.11  by  joerg f. rieling
*-- Author :

c     ------------------------------------------------------------------

      subroutine sgethits (x,cx,IPLANE,NHIT,HITS,MEAS)

      implicit none

c     --- constants

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/SI.fi"
#include "auto/HITB.fi"

#include "susi/zsiconst.fi"
#include "susi/zsihitmark.fi"
#include "susi/zsigeo.fi"

      INTEGER    N_MAX_HITS
      PARAMETER (N_MAX_HITS=3)
c     --- formal parameters
      REAL      X(2),CX(4,4),MEAS(N_MAX_HITS)
      INTEGER   NHIT,HITS(N_MAX_HITS),iPLANE

      REAL     CHIH(N_MAX_HITS),FH,LH,I,CHI2W,CHI2
      REAL     FACT,DETC,Q22,CO,SI,M0,M,CH2MIN
      INTEGER  WORST,ppl,HIT
            

      INTEGER  LENOCC 
      EXTERNAL LENOCC 

c     --- common blocks

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/SI.ff"
#include "auto/HITB.ff"
#include "susi/zsigeo.ff"
#include "susi/zsihitmark.ff"

c     --- init
      nhit = 0
      ppl  = plid (iPLANE)
      co   = plcsr(iPLANE)
      si   = plsnr(iPLANE)
      m0   = X(1)*CO - X(2)*SI ! local coordinate

      nhit = 0 
      FH = IGEPT_HIT1( ppl ) 
      IF( FH .LE. 0 )RETURN 
      LH = IGEPT_HITL( ppl )
      IF( LH .LE. 0 )RETURN


C     invert matric cx 
      Q22  = si*si*CX(2,2)-2.0*SI*CO*CX(1,2)+CO*CO*CX(1,1)
      FACT = Q22
      CH2MIN = FACT*9.0  ! corresponding chi2 cut is 9 !!! 
c
c      dcx = cx(1,1)*cx(2,2)-cx(1,2)**2
c      IF( ABS(dcx).GT. 1.E+4*FSMALLEST)THEN
c       cxi(1,1) =  cxi(2,2)/dcx
c       cxi(2,2) =  cxi(1,1)/dcx
c       cxi(1,1) = -cxi(1,2)/dcx
c       cxi(2,1) = -cxi(2,1)/dcx
c      ELSE 
c       cxi(1,1)=1.0/cx(1,1)
c       cxi(2,2)=1.0/cx(2,2)
c       cxi(1,2)=0.0
c       cxi(2,1)=0.0
c      ENDIF 
cC*    Obtain matrix Q 
c      cxq1(1,1)=co*cxi(1,1)-si*cxi(2,1)
c      cxq1(1,2)=co*cxi(1,2)-si*cxi(2,2)
c      cxq1(2,1)=si*cxi(1,1)+co*cxi(2,1)
c      cxq1(2,2)=si*cxi(1,2)+co*cxi(2,2)
c      cxq(1,1)=cxq1(1,1)*co-cxq1(1,2)*si
c      cxq(1,2)=cxq1(1,1)*si+cxq1(1,1)*co
c      cxq(2,1)=cxq1(2,1)*co-cxq1(2,2)*si
c      cxq(2,2)=cxq1(2,1)*si+cxq1(2,2)*co
c      detq = cxq(1,1)*cxq(2,2)-cxq(1,2)*cxq(2,1)
c      fact = detq/cxq(2,2)
  
      WORST =  1 
      CHI2W = -1.0
      NHIT = 0 
      DO HIT = FH , LH
       M    = FHITB_X( HIT )
       CHI2 = (M-M0)**2
       IF( CHI2 .LE. CH2MIN )THEN 
        IF(     NHIT .EQ. N_MAX_HITS )THEN
C*       hit buffer is full 
C*       Replace the worst hit
         IF( CHI2 .LT. CHI2W )THEN
          HITS( WORST ) = HIT 
          MEAS( WORST ) = M
          CHIH( WORST ) = CHI2  
          WORST =  1 
          CHI2W = -1.0
          DO i=1,NHIT
           IF( CHIH(I) .GT. CHI2W )THEN
            WORST = i 
            CHI2W = CHIH( i ) 
           ENDIF 
          ENDDO                
         ENDIF 
        ELSEIF( NHIT .LT.N_MAX_HITS )THEN 
         NHIT = NHIT + 1 
         HITS( NHIT ) = HIT
         MEAS( NHIT ) = M 
         CHIH( NHIT ) = CHI2 
         IF( CHI2 .GT. CHI2W )THEN
          WORST = NHIT 
          CHI2W = CHI2 
         ENDIF 
        ENDIF 
       ENDIF    
 10    CONTINUE
      ENDDO 
  
      RETURN 
      END



